// ============================ Atmega88 CPU ׽Ʈ α׷ ===================
//  CPU : ATmega88-20M
//     ¥ : 2008-
//      : Ver1.0
//    : www.cpuplaza.com
// Ϸ : Avrstudio
//      : serial 19200,N,8,1
// ----------------------------------------------------------------------------
// ⺻ 
#define	__STDIO_FDEVOPEN_COMPAT_12			// printf()

// === AVR includes ===
#include <stdint.h>
#include <stdio.h>
#include <stdlib.h>
#include <ctype.h>
//#include <float.h>
//#include <math.h>

#include "avr/io.h"
#include "avr/interrupt.h"

//  
#include "cpusetup.inc"						// cpu  ͷƮ  ƾ

// Լ 
void main_menu_disp(void);					//  ޴ ǥ
void cpu_ioport_output(void);					// CPU PORT I/O ׽Ʈ
void timer0_test(void);						// TIMER0 TEST
void timer1_test(void);						// TIMER1 TEST
void timer2_test(void);						// TIMER2 TEST
void exint_test(void);						// EXINT0,1 TEST
void ad_polling_test(void);					// A/D   TEST
unsigned int ad_read(unsigned char adc_input);			// A/D  ( )
void ad_interrupt_test(void);					// A/D ͷƮ  TEST
void ad_start(unsigned char adc_input);				// AD  (ͷƮ ) 
void eeprom_test(void);						// EEPROM TEST
void EEPROM_write(int addr,unsigned char data);			// EEPROM  
unsigned char EEPROM_read(int addr);				// EEPROM  

void urx_string(char buff[]);					// Ʈ 
long atoh(char buff[]);						// ASCII TO HEX 

//  

// ===============================  α׷ ==============================
// [μ]: void
// ---------------------------------------------------------------------------
int main(void)
{
	cpu_setup();						// cpuʱȭ
	main_menu_disp();					//  ޴ ǥ
	while(1){						// Place your code here
		if(com1_rx_eflg){				// COM1  ˻
			if(com1_rx_data == '1') cpu_ioport_output();// CPU I/O PORT TEST
			else if(com1_rx_data == '2') timer0_test(); // TIMER0 TEST
			else if(com1_rx_data == '3') timer1_test(); // TIMER1 TEST
			else if(com1_rx_data == '4') timer2_test(); // TIMER2 TEST
			else if(com1_rx_data == '5') exint_test();  // EXINT0,1 TEST
			else if(com1_rx_data == '6') ad_polling_test();// A/D POLLING TEST
			else if(com1_rx_data == '7') ad_interrupt_test();// A/D POLLING TEST
			else putchar(com1_rx_data);
			com1_rx_eflg = 0;
		}
	}
	return 0;
}

// =====================================  ޴ ǥ =======================
// [μ]: void
// ---------------------------------------------------------------------------
void main_menu_disp(void)
{
	printf("\r\n");
	printf("========= MAIN MENU ======\r\n");
	printf(" 1 : CPU I/O PORT TEST    \r\n");
	printf(" 2 : TIMER0 TEST          \r\n");
	printf(" 3 : TIMER1 TEST          \r\n");
	printf(" 4 : TIMER2 TEST          \r\n");
	printf(" 5 : EXINT0,1 TEST        \r\n");
	printf(" 6 : A/D POLLING   TEST   \r\n");
	printf(" 7 : A/D INTERRUPT TEST   \r\n");
	printf("--------- CPUPLAZA -------\r\n");
}

// =============================== CPUIO TEST =================================
// [μ]: void
// ----------------------------------------------------------------------------
void cpu_ioport_output(void)
{
int out_cnt,exit_flg = 0;

	printf("==== CPU I/O PORT TEST ===\r\n");
	printf(" 0 : TOP menu \r\n");
	printf("--------------------------\r\n");

// CPU PORT   
// PORTB[0..5] : OUT 
	PORTB=0x3f;						// Ʈ  reg
	DDRB=0x3f;						// Ʈ  reg(0Է,1)
// PORTC[0..5] : OUT 
	PORTC=0x3f;						// Ʈ  reg
	DDRC=0x3f;						// Ʈ  reg(0Է,1)
// PORTD[2..7] : OUT 
	PORTD=0xfc;						// Ʈ  reg
	DDRD=0xfc;						// Ʈ  reg(0Է,1)

// LED  Ÿ Timer/Counter0 (Overflow) 9.9984ms
	TCCR0A = 0x00;
	TCCR0B = 0x05;						// system clock,20,000,000 / 1024 = 19.531Khz
	TCNT0 = 60;						// 255-195 = 60	
	OCR0A = 0x00;
	OCR0B = 0x00;
	TIMSK0 |= 0x01;						// TIMER0 ͷƮ 㰡

	timer0_cnt = 0;						// TIMER0 ͷƮ ī Ŭ
	out_cnt = 0;
	com1_rx_eflg = 0;
	while(exit_flg == 0){
		if(com1_rx_eflg){				// COM1  ˻
			if(com1_rx_data == '0') exit_flg = 1;	//  ޴ 
			else putchar(com1_rx_data);		// ݼ
			com1_rx_eflg = 0;
		}
		if(timer0_cnt >= 50){				// 500ms  
			if(out_cnt >= 0 && out_cnt <= 5) PORTB = ~(1 << out_cnt);// PORTB (ش Ʈ 0)
			else if(out_cnt >= 6 && out_cnt <= 11){	// PORTC 
				if(out_cnt == 6) PORTB = 0x3f;	// PORTB CLEAR
				PORTC = ~(1 << (out_cnt-6));	// PORTC (ش Ʈ 0)
			}
			else if(out_cnt >= 12 && out_cnt <= 17){// PORTD 
				if(out_cnt == 12) PORTC = 0x3f;	// PORTC CLEAR
				PORTD = ~(4 << (out_cnt-12));	// PORTD (ش Ʈ 0)
			}
			out_cnt++;				//  ġ ī 
			if(out_cnt >= 19) out_cnt = 0;		//  ġ ʰ ˻
			if(out_cnt == 0){			//  ü ʱȭ
				PORTB = 0x3f;
				PORTC = 0x3f;
				PORTD = 0xfc;
			}
			timer0_cnt = 0;
		}
	}

// Timer/Counter0 
	TCCR0A = 0x00;
	TCCR0B = 0x00;
	TCNT0 = 0;	
	OCR0A = 0x00;
	OCR0B = 0x00;
	TIMSK0 &= 0xfe;						// TIMER0 ͷƮ 

// CPU PORT ʱⰪ  
// PORTB
	PORTB = 0x00;						// Ʈ  reg
	DDRB = 0x00;						// Ʈ  reg(0Է,1)
// PORTC
	PORTC = 0x00;						// Ʈ  reg
	DDRC = 0x00;						// Ʈ  reg(0Է,1)
// PORTD
	PORTD = 0x00;						// Ʈ  reg
	DDRD = 0x00;						// Ʈ  reg(0Է,1)
	
	main_menu_disp();					//  ޴ ǥ
}

// ============================== TIMER0 TEST =================================
// [μ]: void
// ----------------------------------------------------------------------------
void timer0_test(void)
{
int exit_flg = 0;

	printf("=== TIMER0 TEST ===\r\n");
	printf(" 0 : TOP menu \r\n");
	printf("-------------------\r\n");

// Timer/Counter0 (Overflow)
	TCCR0A = 0x00;
	TCCR0B = 0x05;						// system clock,20,000,000 / 1024 = 19.531Khz
	TCNT0 = 60;						// 255-195 = 60	
	OCR0A = 0x00;
	OCR0B = 0x00;
	TIMSK0 |= 0x01;						// TIMER0 ͷƮ 㰡
	
	timer0_cnt = 0;						// TIMER0 ͷƮ ī Ŭ
	com1_rx_eflg = 0;
	while(exit_flg == 0){
		if(com1_rx_eflg){				// COM1  ˻
			if(com1_rx_data == '0') exit_flg = 1;	//  ޴ 
			else putchar(com1_rx_data);		// ݼ
			com1_rx_eflg = 0;
		}
		if(timer0_cnt >= 100){				// 999.84ms üũ
			printf("TIMER0 Overflow Int\r\n");
			timer0_cnt = 0;
		}
	}

// Timer/Counter0 
	TCCR0A = 0x00;
	TCCR0B = 0x00;
	TCNT0 = 0;	
	OCR0A = 0x00;
	OCR0B = 0x00;
	TIMSK0 &= 0xfe;						// TIMER0 ͷƮ 
	
	main_menu_disp();					//  ޴ ǥ
}

// ============================== TIMER1 TEST =================================
// [μ]: void
// ----------------------------------------------------------------------------
void timer1_test(void)
{
int exit_flg = 0;

	printf("=== TIMER1 TEST ===\r\n");
	printf(" 0 : TOP menu \r\n");
	printf("-------------------\r\n");

// Timer/Counter1 (Overflow)
	TCCR1A = 0x00;
	TCCR1B = 0x03;						// system clock,20,000,000 / 64 = 312.500Khz
	TCNT1H = 0xf3;						// 65535 - 3120 = 62415
	TCNT1L = 0xcf;
	ICR1H  = 0x00;
	ICR1L = 0x00;
	OCR1AH = 0x00;
	OCR1AL = 0x00;
	OCR1BH = 0x00;
	OCR1BL = 0x00;	
	TIMSK1 |= 0x01;						// TIMER1 ͷƮ 㰡
	
	timer1_cnt = 0;						// TIMER1 ͷƮ ī Ŭ
	com1_rx_eflg = 0;
	while(exit_flg == 0){					// COM1  ˻
		if(com1_rx_eflg){
			if(com1_rx_data == '0') exit_flg = 1;	//  ޴ 
			else putchar(com1_rx_data);		// ݼ
			com1_rx_eflg = 0;
		}
		if(timer1_cnt >= 100){				// 1s üũ
			printf("TIMER1 Overflow Int\r\n");
			timer1_cnt = 0;
		}
	}

// Timer/Counter1 
	TCCR1A = 0x00;
	TCCR1B = 0x00;
	TCNT1H = 0x00;
	TCNT1L = 0x00;
	ICR1H  = 0x00;
	ICR1L = 0x00;
	OCR1AH = 0x00;
	OCR1AL = 0x00;
	OCR1BH = 0x00;
	OCR1BL = 0x00;	
	TIMSK1 &= 0xfe;						// TIMER1 ͷƮ 
	
	main_menu_disp();					//  ޴ ǥ
}

// ============================== TIMER2 TEST =================================
// [μ]: void
// ----------------------------------------------------------------------------
void timer2_test(void)
{
int exit_flg = 0;

	printf("=== TIMER2 TEST ===\r\n");
	printf(" 0 : TOP menu \r\n");
	printf("-------------------\r\n");

// Timer/Counter2 (Overflow)
	ASSR = 0x00;
	TCCR2A = 0x00;
	TCCR2B = 0x07;						// system clock,20,000,000 / 1024 = 19.531Khz
	TCNT2 = 60;						// 255-195 = 60
	OCR2A = 0x00;
	OCR2B = 0x00;
	TIMSK2 |= 0x01;						// TIMER2 ͷƮ 
	
	timer2_cnt = 0;						// TIMER2 ͷƮ ī Ŭ
	com1_rx_eflg = 0;
	while(exit_flg == 0){
		if(com1_rx_eflg){				// COM1  ˻
			if(com1_rx_data == '0') exit_flg = 1;	//  ޴ 
			else putchar(com1_rx_data);		// ݼ
			com1_rx_eflg = 0;
		}
		if(timer2_cnt >= 100){				// 999.84ms üũ
			printf("TIMER2 Overflow Int\r\n");
			timer2_cnt = 0;
		}
	}

// Timer/Counter2 
	ASSR = 0x00;
	TCCR2A = 0x00;
	TCCR2B = 0x00;
	TCNT2 = 0x00;
	OCR2A = 0x00;
	OCR2B = 0x00;
	TIMSK2 &= 0xfe;						// TIMER2 ͷƮ 
	
	main_menu_disp();					//  ޴ ǥ
}

// ============================== EXINT0,1 TEST ===============================
// [μ]: void
// ----------------------------------------------------------------------------
void exint_test(void)
{
int exit_flg = 0;

	printf("=== EXINT0,1 TEST ===\r\n");
	printf(" 0 : TOP menu \r\n");
	printf("     INT0,1 Falling Edge \r\n");
	printf("-------------==------\r\n");

// External Interrupt(s) 
// INT0 Mode: Falling Edge
// INT1 Mode: Falling Edge
	EICRA=0x0A;
	EIMSK=0x03;
	EIFR=0x03;
	PCICR=0x00;
	
	exint0_flg = exint1_flg = 0;				// EXINT0,1 ͷƮ ÷ Ŭ
	com1_rx_eflg = 0;
	while(exit_flg == 0){
		if(com1_rx_eflg){				// COM1  ˻
			if(com1_rx_data == '0') exit_flg = 1;	//  ޴ 
			else putchar(com1_rx_data);		// ݼ
			com1_rx_eflg = 0;
		}
		if(exint0_flg){					// EXINT0 ͷƮ ÷ üũ
			printf("EXINT0\r\n");
			exint0_flg = 0;
		}
		if(exint1_flg){					// EXINT1 ͷƮ ÷ üũ
			printf("EXINT1\r\n");
			exint1_flg = 0;
		}
	}

// External Interrupt(s) 
	EICRA=0x00;
	EIMSK=0x00;
	EIFR=0x00;
	PCICR=0x00;
	
	main_menu_disp();					//  ޴ ǥ
}


// ============================== A/D POLLING TEST ============================
// [μ]: void
// ----------------------------------------------------------------------------
void ad_polling_test(void)
{
unsigned datau = 0;
int exit_flg = 0;

	printf("=== A/D POLLING TEST ===\r\n");
	printf(" 0  : TOP menu \r\n");
	printf(" 1-8: CH0-7 READ \r\n");
	printf("------------------------\r\n");

// ADC initialization 
// 312.500kHz,AREF
	DIDR0=0x00;
	ADMUX=0x00;
	ADCSRA=0x86;
	
	com1_rx_eflg = 0;
	while(exit_flg == 0){
		if(com1_rx_eflg){				// COM1  ˻
			if(com1_rx_data == '0') exit_flg = 1;	//  ޴ 
			else if(com1_rx_data == '1') datau = ad_read(0);// CH0 
			else if(com1_rx_data == '2') datau = ad_read(1);// CH1 
			else if(com1_rx_data == '3') datau = ad_read(2);// CH2 
			else if(com1_rx_data == '4') datau = ad_read(3);// CH3 
			else if(com1_rx_data == '5') datau = ad_read(4);// CH4 
			else if(com1_rx_data == '6') datau = ad_read(5);// CH5 
			else if(com1_rx_data == '7') datau = ad_read(6);// CH6 
			else if(com1_rx_data == '8') datau = ad_read(7);// CH7 
			else putchar(com1_rx_data);		// ݼ
			// A/D  ǥ
			if(com1_rx_data >= '1' && com1_rx_data <= '8'){
				printf("ADC CH%d > %d\r\n",(com1_rx_data&0x0f)-1,datau);
			}
			com1_rx_eflg = 0;
		}
	}

// ADC initialization 
	DIDR0=0x00;
	ADMUX=0x00;
	ADCSRA=0x00;
	ADCSRB&=0xf8;	
	
	main_menu_disp();					//  ޴ ǥ
}

// ============================== A/D POLLING TEST ============================
// [μ]: unsigned char adc_input
// ITEM1 : AD CH(0-7)
// []: A/D 10bit
// ----------------------------------------------------------------------------
unsigned int ad_read(unsigned char adc_input)
{
	ADMUX = adc_input;					// ADREF(0) + CH
	ADCSRA |= 0x40;						// AD conversion 
	while((ADCSRA & 0x10) == 0);				//  Ϸ 
	ADCSRA |= 0x10;						// AD ÷ Ŭ
	return ADCW;
}


// ============================== A/D INTERRUPT TEST ==========================
// [μ]: void
// ----------------------------------------------------------------------------
void ad_interrupt_test(void)
{
int exit_flg = 0;

	printf("=== A/D INTEERRUPT TEST ===\r\n");
	printf(" 0  : TOP menu \r\n");
	printf(" 1-8: CH0-7 READ \r\n");
	printf("---------------------------\r\n");

// ADC initialization 
// ADC initialization 
// 312.500kHz,AREF :: ȯ ͷƮ
	DIDR0=0x00;
	ADMUX=0x00;
	ADCSRA=0x8e;
	
	adc_int_flg = 0;					// ADCϷ ͷƮ ÷
	adc_int_ch = 0;						// ADC CH = CH0
	com1_rx_eflg = 0;
	while(exit_flg == 0){
		if(com1_rx_eflg){				// COM1  ˻
			if(com1_rx_data == '0') exit_flg = 1;	//  ޴ 
			else if(com1_rx_data == '1') ad_start(0);// CH0 
			else if(com1_rx_data == '2') ad_start(1);// CH1 
			else if(com1_rx_data == '3') ad_start(2);// CH2 
			else if(com1_rx_data == '4') ad_start(3);// CH3 
			else if(com1_rx_data == '5') ad_start(4);// CH4 
			else if(com1_rx_data == '6') ad_start(5);// CH5 
			else if(com1_rx_data == '7') ad_start(6);// CH6 
			else if(com1_rx_data == '8') ad_start(7);// CH7 
			else putchar(com1_rx_data);		// ݼ
			// A/D  ǥ
			if(com1_rx_data >= '1' && com1_rx_data <= '8') printf("STAT ADC ");
			com1_rx_eflg = 0;
		}
		if(adc_int_flg){				// ADC  Ϸ ͷƮ ÷ 
			printf("CH%d > %d\r\n",adc_int_ch,adc_int_data);// ADC CH  ǥ
			adc_int_flg = 0;
		}
	}

// ADC initialization 
	DIDR0=0x00;
	ADMUX=0x00;
	ADCSRA=0x00;
	
	main_menu_disp();					//  ޴ ǥ
}

// ============================== A/D POLLING TEST ============================
// [μ]: unsigned char adc_input
// ITEM1 : AD CH(0-7)
// []: A/D 10bit
// ----------------------------------------------------------------------------
void ad_start(unsigned char adc_input)
{
	adc_int_ch = adc_input;				// ADC CH 
	ADMUX = adc_input;					// ADREF(0) + CH
	ADCSRA |= 0x40;						// AD conversion 
}

// ============================== EEPROM DATA READ ============================
// [μ] int addr
// Item1:  ּ(0 - 511)
// []  (00 - ff)
// ----------------------------------------------------------------------------
unsigned char EEPROM_read(int addr)
{
unsigned char ch;

	while(EECR & 0x02);					//   Ϸñ 
	EEAR = addr;
	EECR |= 0x01;
	ch = EEDR;
	return(ch);
}

// ============================== EEPROM DATA  ============================
// [μ] int addr,unsigned char data
// Item1:  ּ(0 - 511)
// Item2:  (00 - ff)
// ----------------------------------------------------------------------------
void EEPROM_write(int addr,unsigned char data)
{
	while(EECR & 0x02);					//   Ϸñ 
	EEAR = addr;
	EEDR = data;
	EECR |= 0x04;
	EECR |= 0x02;
}
