// =================================== CPUʱȭ ͷƮ ===================
//      : CPU  ϰ ͷƮ  ƾ .
// ----------------------------------------------------------------------------
//   
#define RXB8 1
#define TXB8 0
#define UPE 2
#define OVR 3
#define FE 4
#define UDRE 5
#define RXC 7

#define FRAMING_ERROR (1<<FE)
#define PARITY_ERROR (1<<UPE)
#define DATA_OVERRUN (1<<OVR)
#define DATA_REGISTER_EMPTY (1<<UDRE)
#define RX_COMPLETE (1<<RXC)

//  
char com1_rx_data,com1_rx_eflg = 0;				//   ͷƮ  /÷

int timer0_cnt = 0;						// Ÿ̸0 ͷƮ  ī
int timer1_cnt = 0;						// Ÿ̸1 ͷƮ  ī
int timer2_cnt = 0;						// Ÿ̸2 ͷƮ  ī

int exint0_flg = 0;						// EXINT0 ͷƮ  ÷
int exint1_flg = 0;						// EXINT1 ͷƮ  ÷

unsigned int adc_int_data = 0;					// ADC ͷƮ  
int adc_int_ch = 0;						// ADC CH ͷƮ 
int adc_int_flg = 0;						// ADC ͷƮ  ÷

// ===================================== CPUʱȭ ============================
// [μ] void
// ----------------------------------------------------------------------------
void cpu_setup(void)
{
// Crystal Oscillator division factor: 1
#pragma optsize-
	CLKPR=0x80;
	CLKPR=0x00;
#ifdef _OPTIMIZE_SIZE_
#pragma optsize+
#endif

// PortB 
	PORTB=0x00;						// Ʈ  reg
	DDRB=0x00;						// Ʈ  reg(0Է,1)

// PortC 
	PORTC=0x00;						// Ʈ  reg             
	DDRC=0x00;                                              // Ʈ  reg(0Է,1)

// PortD 
	PORTD=0x00;						// Ʈ  reg             
	DDRD=0x00;                                              // Ʈ  reg(0Է,1)

// Timer/Counter0 
        TCCR0A=0x00;
        TCCR0B=0x00;
        TCNT0=0x00;
        OCR0A=0x00;
        OCR0B=0x00;
	
// Timer/Counter1 
	TCCR1A=0x00;
	TCCR1B=0x00;
	TCNT1H=0x00;
	TCNT1L=0x00;
	ICR1H=0x00;
	ICR1L=0x00;
	OCR1AH=0x00;
	OCR1AL=0x00;
	OCR1BH=0x00;
	OCR1BL=0x00;

// Timer/Counter2 
	ASSR=0x00;
	TCCR2A=0x00;
	TCCR2B=0x00;
	TCNT2=0x00;
	OCR2A=0x00;
	OCR2B=0x00;

// External Interrupt(s) 
// INT0: Off
// INT1: Off
	EICRA=0x00;
	EIMSK=0x00;
	EIFR=0x00;
	PCICR=0x00;

// Timer(s)/Counter(s) Interrupt(s) 
	TIMSK0=0x00;
	TIMSK1=0x00;
	TIMSK2=0x00;

//  ʱȭ
// 19200Bps, 8Data, 1 Stop, No Parity
	UCSR0A=0x00;
	UCSR0B=0x98;
	UCSR0C=0x06;
	UBRR0H=0x00;
	UBRR0L=0x40;

// Analog Comparator 
	ACSR=0x80;
	ADCSRB=0x00;

// Global enable interrupts
#asm("sei")
}

// ================================  ͷƮ =============================
// [μ] void
// ----------------------------------------------------------------------------
#pragma savereg-
interrupt [USART_RXC] void uart_rx_isr(void)
{
char status,data;
#asm
	push r26
	push r27
	push r30
	push r31
	in   r26,sreg
	push r26
#endasm

	status = UCSR0A;
	data = UDR0;
	if((status & (FRAMING_ERROR | PARITY_ERROR | DATA_OVERRUN))==0){
		com1_rx_data = data;
		com1_rx_eflg = 1;
	}

#asm
	pop  r26
	out  sreg,r26
	pop  r31
	pop  r30
	pop  r27
	pop  r26
#endasm
}
#pragma savereg+

// ========================== TIMER0 overflow ͷƮ ========================
// [μ] void
// [] 20,000,000 / 1024 / 195 =  1 / 100.1602564 = 9.9984ms
// ----------------------------------------------------------------------------
interrupt [TIM0_OVF] void timer0_ovf_isr(void)
{
	TCNT0 = 60;						// 255-195 = 60
	timer0_cnt++;						// Ÿ̸0 ī
}

// ========================== TIMER1 overflow ͷƮ ========================
// [μ] void
// [] 20,000,000 / 64 / 3120 =  1 / 100.0 = 9.9984ms
// ----------------------------------------------------------------------------
interrupt [TIM1_OVF] void timer1_ovf_isr(void)
{
	TCNT1H = 0xf3;						// 65535 - 3120 = 62415
	TCNT1L = 0xcf;
	timer1_cnt++;						// Ÿ̸1 ī
}

// ========================== TIMER2 overflow ͷƮ ========================
// [μ] void
// [] 20,000,000 / 1024 / 156 =  1 / 100.1602564 = 9.9984ms
// ----------------------------------------------------------------------------
interrupt [TIM2_OVF] void timer2_ovf_isr(void)
{
	TCNT2 = 60;						// 255-195 = 60
	timer2_cnt++;						// Ÿ̸2 ī
}

// ========================== ܺ INT0 ͷƮ ==============================
// [μ] void
// ----------------------------------------------------------------------------
interrupt [EXT_INT0] void ext_int0_isr(void)
{
	exint0_flg = 1;						// EXINT0 ÷ ON
}

// ========================== ܺ INT1 ͷƮ ==============================
// [μ] void
// ----------------------------------------------------------------------------
interrupt [EXT_INT1] void ext_int1_isr(void)
{
	exint1_flg = 1;						// EXINT1 ÷ ON
}

// =============================== ADC ͷƮ ===============================
// [μ] void
// ----------------------------------------------------------------------------
interrupt [ADC_INT] void adc_isr(void)
{
	adc_int_data = ADCW;					// ADC
	adc_int_flg = 1;					// ADC Ϸ ÷ 
}
