
;CodeVisionAVR C Compiler V1.25.3 Standard
;(C) Copyright 1998-2007 Pavel Haiduc, HP InfoTech s.r.l.
;http://www.hpinfotech.com

;Chip type              : ATmega88
;Program type           : Application
;Clock frequency        : 20.000000 MHz
;Memory model           : Small
;Optimize for           : Size
;(s)printf features     : int, width
;(s)scanf features      : int, width
;External SRAM size     : 0
;Data Stack size        : 300 byte(s)
;Heap size              : 0 byte(s)
;Promote char to int    : No
;char is unsigned       : Yes
;8 bit enums            : Yes
;Word align FLASH struct: Yes
;Enhanced core instructions    : On
;Smart register allocation : On
;Automatic register allocation : On

	#pragma AVRPART ADMIN PART_NAME ATmega88
	#pragma AVRPART MEMORY PROG_FLASH 8192
	#pragma AVRPART MEMORY EEPROM 512
	#pragma AVRPART MEMORY INT_SRAM SIZE 1024
	#pragma AVRPART MEMORY INT_SRAM START_ADDR 0x100

	.EQU EERE=0x0
	.EQU EEWE=0x1
	.EQU EEMWE=0x2
	.EQU UDRE=0x5
	.EQU RXC=0x7
	.EQU EECR=0x1F
	.EQU EEDR=0x20
	.EQU EEARL=0x21
	.EQU EEARH=0x22
	.EQU SPSR=0x2D
	.EQU SPDR=0x2E
	.EQU SMCR=0x33
	.EQU MCUSR=0x34
	.EQU MCUCR=0x35
	.EQU WDTCSR=0x60
	.EQU UCSR0A=0xC0
	.EQU UDR0=0xC6
	.EQU SPL=0x3D
	.EQU SPH=0x3E
	.EQU SREG=0x3F
	.EQU GPIOR0=0x1E
	.EQU GPIOR1=0x2A
	.EQU GPIOR2=0x2B

	.DEF R0X0=R0
	.DEF R0X1=R1
	.DEF R0X2=R2
	.DEF R0X3=R3
	.DEF R0X4=R4
	.DEF R0X5=R5
	.DEF R0X6=R6
	.DEF R0X7=R7
	.DEF R0X8=R8
	.DEF R0X9=R9
	.DEF R0XA=R10
	.DEF R0XB=R11
	.DEF R0XC=R12
	.DEF R0XD=R13
	.DEF R0XE=R14
	.DEF R0XF=R15
	.DEF R0X10=R16
	.DEF R0X11=R17
	.DEF R0X12=R18
	.DEF R0X13=R19
	.DEF R0X14=R20
	.DEF R0X15=R21
	.DEF R0X16=R22
	.DEF R0X17=R23
	.DEF R0X18=R24
	.DEF R0X19=R25
	.DEF R0X1A=R26
	.DEF R0X1B=R27
	.DEF R0X1C=R28
	.DEF R0X1D=R29
	.DEF R0X1E=R30
	.DEF R0X1F=R31

	.EQU __se_bit=0x01
	.EQU __sm_mask=0x0E
	.EQU __sm_adc_noise_red=0x02
	.EQU __sm_powerdown=0x04
	.EQU __sm_powersave=0x06
	.EQU __sm_standby=0x0C

	.MACRO __CPD1N
	CPI  R30,LOW(@0)
	LDI  R26,HIGH(@0)
	CPC  R31,R26
	LDI  R26,BYTE3(@0)
	CPC  R22,R26
	LDI  R26,BYTE4(@0)
	CPC  R23,R26
	.ENDM

	.MACRO __CPD2N
	CPI  R26,LOW(@0)
	LDI  R30,HIGH(@0)
	CPC  R27,R30
	LDI  R30,BYTE3(@0)
	CPC  R24,R30
	LDI  R30,BYTE4(@0)
	CPC  R25,R30
	.ENDM

	.MACRO __CPWRR
	CP   R@0,R@2
	CPC  R@1,R@3
	.ENDM

	.MACRO __CPWRN
	CPI  R@0,LOW(@2)
	LDI  R30,HIGH(@2)
	CPC  R@1,R30
	.ENDM

	.MACRO __ADDB1MN
	SUBI R30,LOW(-@0-(@1))
	.ENDM
	.MACRO __ADDB2MN
	SUBI R26,LOW(-@0-(@1))
	.ENDM
	.MACRO __ADDW1MN
	SUBI R30,LOW(-@0-(@1))
	SBCI R31,HIGH(-@0-(@1))
	.ENDM
	.MACRO __ADDW2MN
	SUBI R26,LOW(-@0-(@1))
	SBCI R27,HIGH(-@0-(@1))
	.ENDM
	.MACRO __ADDW1FN
	SUBI R30,LOW(-2*@0-(@1))
	SBCI R31,HIGH(-2*@0-(@1))
	.ENDM
	.MACRO __ADDD1FN
	SUBI R30,LOW(-2*@0-(@1))
	SBCI R31,HIGH(-2*@0-(@1))
	SBCI R22,BYTE3(-2*@0-(@1))
	.ENDM
	.MACRO __ADDD1N
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	SBCI R22,BYTE3(-@0)
	SBCI R23,BYTE4(-@0)
	.ENDM

	.MACRO __ADDD2N
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	SBCI R24,BYTE3(-@0)
	SBCI R25,BYTE4(-@0)
	.ENDM

	.MACRO __SUBD1N
	SUBI R30,LOW(@0)
	SBCI R31,HIGH(@0)
	SBCI R22,BYTE3(@0)
	SBCI R23,BYTE4(@0)
	.ENDM

	.MACRO __SUBD2N
	SUBI R26,LOW(@0)
	SBCI R27,HIGH(@0)
	SBCI R24,BYTE3(@0)
	SBCI R25,BYTE4(@0)
	.ENDM

	.MACRO __ANDBMNN
	LDS  R30,@0+@1
	ANDI R30,LOW(@2)
	STS  @0+@1,R30
	.ENDM

	.MACRO __ANDWMNN
	LDS  R30,@0+@1
	ANDI R30,LOW(@2)
	STS  @0+@1,R30
	LDS  R30,@0+@1+1
	ANDI R30,HIGH(@2)
	STS  @0+@1+1,R30
	.ENDM

	.MACRO __ANDD1N
	ANDI R30,LOW(@0)
	ANDI R31,HIGH(@0)
	ANDI R22,BYTE3(@0)
	ANDI R23,BYTE4(@0)
	.ENDM

	.MACRO __ORBMNN
	LDS  R30,@0+@1
	ORI  R30,LOW(@2)
	STS  @0+@1,R30
	.ENDM

	.MACRO __ORWMNN
	LDS  R30,@0+@1
	ORI  R30,LOW(@2)
	STS  @0+@1,R30
	LDS  R30,@0+@1+1
	ORI  R30,HIGH(@2)
	STS  @0+@1+1,R30
	.ENDM

	.MACRO __ORD1N
	ORI  R30,LOW(@0)
	ORI  R31,HIGH(@0)
	ORI  R22,BYTE3(@0)
	ORI  R23,BYTE4(@0)
	.ENDM

	.MACRO __DELAY_USB
	LDI  R24,LOW(@0)
__DELAY_USB_LOOP:
	DEC  R24
	BRNE __DELAY_USB_LOOP
	.ENDM

	.MACRO __DELAY_USW
	LDI  R24,LOW(@0)
	LDI  R25,HIGH(@0)
__DELAY_USW_LOOP:
	SBIW R24,1
	BRNE __DELAY_USW_LOOP
	.ENDM

	.MACRO __CLRD1S
	LDI  R30,0
	STD  Y+@0,R30
	STD  Y+@0+1,R30
	STD  Y+@0+2,R30
	STD  Y+@0+3,R30
	.ENDM

	.MACRO __GETD1S
	LDD  R30,Y+@0
	LDD  R31,Y+@0+1
	LDD  R22,Y+@0+2
	LDD  R23,Y+@0+3
	.ENDM

	.MACRO __PUTD1S
	STD  Y+@0,R30
	STD  Y+@0+1,R31
	STD  Y+@0+2,R22
	STD  Y+@0+3,R23
	.ENDM

	.MACRO __PUTD2S
	STD  Y+@0,R26
	STD  Y+@0+1,R27
	STD  Y+@0+2,R24
	STD  Y+@0+3,R25
	.ENDM

	.MACRO __POINTB1MN
	LDI  R30,LOW(@0+@1)
	.ENDM

	.MACRO __POINTW1MN
	LDI  R30,LOW(@0+@1)
	LDI  R31,HIGH(@0+@1)
	.ENDM

	.MACRO __POINTD1M
	LDI  R30,LOW(@0)
	LDI  R31,HIGH(@0)
	LDI  R22,BYTE3(@0)
	.ENDM

	.MACRO __POINTW1FN
	LDI  R30,LOW(2*@0+@1)
	LDI  R31,HIGH(2*@0+@1)
	.ENDM

	.MACRO __POINTD1FN
	LDI  R30,LOW(2*@0+@1)
	LDI  R31,HIGH(2*@0+@1)
	LDI  R22,BYTE3(2*@0+@1)
	.ENDM

	.MACRO __POINTB2MN
	LDI  R26,LOW(@0+@1)
	.ENDM

	.MACRO __POINTW2MN
	LDI  R26,LOW(@0+@1)
	LDI  R27,HIGH(@0+@1)
	.ENDM

	.MACRO __POINTBRM
	LDI  R@0,LOW(@1)
	.ENDM

	.MACRO __POINTWRM
	LDI  R@0,LOW(@2)
	LDI  R@1,HIGH(@2)
	.ENDM

	.MACRO __POINTBRMN
	LDI  R@0,LOW(@1+@2)
	.ENDM

	.MACRO __POINTWRMN
	LDI  R@0,LOW(@2+@3)
	LDI  R@1,HIGH(@2+@3)
	.ENDM

	.MACRO __POINTWRFN
	LDI  R@0,LOW(@2*2+@3)
	LDI  R@1,HIGH(@2*2+@3)
	.ENDM

	.MACRO __GETD1N
	LDI  R30,LOW(@0)
	LDI  R31,HIGH(@0)
	LDI  R22,BYTE3(@0)
	LDI  R23,BYTE4(@0)
	.ENDM

	.MACRO __GETD2N
	LDI  R26,LOW(@0)
	LDI  R27,HIGH(@0)
	LDI  R24,BYTE3(@0)
	LDI  R25,BYTE4(@0)
	.ENDM

	.MACRO __GETD2S
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	LDD  R24,Y+@0+2
	LDD  R25,Y+@0+3
	.ENDM

	.MACRO __GETB1MN
	LDS  R30,@0+@1
	.ENDM

	.MACRO __GETB1HMN
	LDS  R31,@0+@1
	.ENDM

	.MACRO __GETW1MN
	LDS  R30,@0+@1
	LDS  R31,@0+@1+1
	.ENDM

	.MACRO __GETD1MN
	LDS  R30,@0+@1
	LDS  R31,@0+@1+1
	LDS  R22,@0+@1+2
	LDS  R23,@0+@1+3
	.ENDM

	.MACRO __GETBRMN
	LDS  R@0,@1+@2
	.ENDM

	.MACRO __GETWRMN
	LDS  R@0,@2+@3
	LDS  R@1,@2+@3+1
	.ENDM

	.MACRO __GETWRZ
	LDD  R@0,Z+@2
	LDD  R@1,Z+@2+1
	.ENDM

	.MACRO __GETD2Z
	LDD  R26,Z+@0
	LDD  R27,Z+@0+1
	LDD  R24,Z+@0+2
	LDD  R25,Z+@0+3
	.ENDM

	.MACRO __GETB2MN
	LDS  R26,@0+@1
	.ENDM

	.MACRO __GETW2MN
	LDS  R26,@0+@1
	LDS  R27,@0+@1+1
	.ENDM

	.MACRO __GETD2MN
	LDS  R26,@0+@1
	LDS  R27,@0+@1+1
	LDS  R24,@0+@1+2
	LDS  R25,@0+@1+3
	.ENDM

	.MACRO __PUTB1MN
	STS  @0+@1,R30
	.ENDM

	.MACRO __PUTW1MN
	STS  @0+@1,R30
	STS  @0+@1+1,R31
	.ENDM

	.MACRO __PUTD1MN
	STS  @0+@1,R30
	STS  @0+@1+1,R31
	STS  @0+@1+2,R22
	STS  @0+@1+3,R23
	.ENDM

	.MACRO __PUTBR0MN
	STS  @0+@1,R0
	.ENDM

	.MACRO __PUTDZ2
	STD  Z+@0,R26
	STD  Z+@0+1,R27
	STD  Z+@0+2,R24
	STD  Z+@0+3,R25
	.ENDM

	.MACRO __PUTBMRN
	STS  @0+@1,R@2
	.ENDM

	.MACRO __PUTWMRN
	STS  @0+@1,R@2
	STS  @0+@1+1,R@3
	.ENDM

	.MACRO __PUTBZR
	STD  Z+@1,R@0
	.ENDM

	.MACRO __PUTWZR
	STD  Z+@2,R@0
	STD  Z+@2+1,R@1
	.ENDM

	.MACRO __GETW1R
	MOV  R30,R@0
	MOV  R31,R@1
	.ENDM

	.MACRO __GETW2R
	MOV  R26,R@0
	MOV  R27,R@1
	.ENDM

	.MACRO __GETWRN
	LDI  R@0,LOW(@2)
	LDI  R@1,HIGH(@2)
	.ENDM

	.MACRO __PUTW1R
	MOV  R@0,R30
	MOV  R@1,R31
	.ENDM

	.MACRO __PUTW2R
	MOV  R@0,R26
	MOV  R@1,R27
	.ENDM

	.MACRO __ADDWRN
	SUBI R@0,LOW(-@2)
	SBCI R@1,HIGH(-@2)
	.ENDM

	.MACRO __ADDWRR
	ADD  R@0,R@2
	ADC  R@1,R@3
	.ENDM

	.MACRO __SUBWRN
	SUBI R@0,LOW(@2)
	SBCI R@1,HIGH(@2)
	.ENDM

	.MACRO __SUBWRR
	SUB  R@0,R@2
	SBC  R@1,R@3
	.ENDM

	.MACRO __ANDWRN
	ANDI R@0,LOW(@2)
	ANDI R@1,HIGH(@2)
	.ENDM

	.MACRO __ANDWRR
	AND  R@0,R@2
	AND  R@1,R@3
	.ENDM

	.MACRO __ORWRN
	ORI  R@0,LOW(@2)
	ORI  R@1,HIGH(@2)
	.ENDM

	.MACRO __ORWRR
	OR   R@0,R@2
	OR   R@1,R@3
	.ENDM

	.MACRO __EORWRR
	EOR  R@0,R@2
	EOR  R@1,R@3
	.ENDM

	.MACRO __GETWRS
	LDD  R@0,Y+@2
	LDD  R@1,Y+@2+1
	.ENDM

	.MACRO __PUTWSR
	STD  Y+@2,R@0
	STD  Y+@2+1,R@1
	.ENDM

	.MACRO __MOVEWRR
	MOV  R@0,R@2
	MOV  R@1,R@3
	.ENDM

	.MACRO __INWR
	IN   R@0,@2
	IN   R@1,@2+1
	.ENDM

	.MACRO __OUTWR
	OUT  @2+1,R@1
	OUT  @2,R@0
	.ENDM

	.MACRO __CALL1MN
	LDS  R30,@0+@1
	LDS  R31,@0+@1+1
	ICALL
	.ENDM

	.MACRO __CALL1FN
	LDI  R30,LOW(2*@0+@1)
	LDI  R31,HIGH(2*@0+@1)
	RCALL __GETW1PF
	ICALL
	.ENDM

	.MACRO __CALL2EN
	LDI  R26,LOW(@0+@1)
	LDI  R27,HIGH(@0+@1)
	RCALL __EEPROMRDW
	ICALL
	.ENDM

	.MACRO __GETW1STACK
	IN   R26,SPL
	IN   R27,SPH
	ADIW R26,@0+1
	LD   R30,X+
	LD   R31,X
	.ENDM

	.MACRO __NBST
	BST  R@0,@1
	IN   R30,SREG
	LDI  R31,0x40
	EOR  R30,R31
	OUT  SREG,R30
	.ENDM


	.MACRO __PUTB1SN
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SN
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SN
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1SNS
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	ADIW R26,@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SNS
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	ADIW R26,@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SNS
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	ADIW R26,@1
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1PMN
	LDS  R26,@0
	LDS  R27,@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1PMN
	LDS  R26,@0
	LDS  R27,@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1PMN
	LDS  R26,@0
	LDS  R27,@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1PMNS
	LDS  R26,@0
	LDS  R27,@0+1
	ADIW R26,@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1PMNS
	LDS  R26,@0
	LDS  R27,@0+1
	ADIW R26,@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1PMNS
	LDS  R26,@0
	LDS  R27,@0+1
	ADIW R26,@1
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RN
	MOVW R26,R@0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RN
	MOVW R26,R@0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RN
	MOVW R26,R@0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RNS
	MOVW R26,R@0
	ADIW R26,@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RNS
	MOVW R26,R@0
	ADIW R26,@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RNS
	MOVW R26,R@0
	ADIW R26,@1
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RON
	MOV  R26,R@0
	MOV  R27,R@1
	SUBI R26,LOW(-@2)
	SBCI R27,HIGH(-@2)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RON
	MOV  R26,R@0
	MOV  R27,R@1
	SUBI R26,LOW(-@2)
	SBCI R27,HIGH(-@2)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RON
	MOV  R26,R@0
	MOV  R27,R@1
	SUBI R26,LOW(-@2)
	SBCI R27,HIGH(-@2)
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RONS
	MOV  R26,R@0
	MOV  R27,R@1
	ADIW R26,@2
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RONS
	MOV  R26,R@0
	MOV  R27,R@1
	ADIW R26,@2
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RONS
	MOV  R26,R@0
	MOV  R27,R@1
	ADIW R26,@2
	RCALL __PUTDP1
	.ENDM


	.MACRO __GETB1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R30,Z
	.ENDM

	.MACRO __GETB1HSX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R31,Z
	.ENDM

	.MACRO __GETW1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R0,Z+
	LD   R31,Z
	MOV  R30,R0
	.ENDM

	.MACRO __GETD1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R0,Z+
	LD   R1,Z+
	LD   R22,Z+
	LD   R23,Z
	MOVW R30,R0
	.ENDM

	.MACRO __GETB2SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R26,X
	.ENDM

	.MACRO __GETW2SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	.ENDM

	.MACRO __GETD2SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R1,X+
	LD   R24,X+
	LD   R25,X
	MOVW R26,R0
	.ENDM

	.MACRO __GETBRSX
	MOVW R30,R28
	SUBI R30,LOW(-@1)
	SBCI R31,HIGH(-@1)
	LD   R@0,Z
	.ENDM

	.MACRO __GETWRSX
	MOVW R30,R28
	SUBI R30,LOW(-@2)
	SBCI R31,HIGH(-@2)
	LD   R@0,Z+
	LD   R@1,Z
	.ENDM

	.MACRO __LSLW8SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R31,Z
	CLR  R30
	.ENDM

	.MACRO __PUTB1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X+,R30
	ST   X+,R31
	ST   X+,R22
	ST   X,R23
	.ENDM

	.MACRO __CLRW1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	CLR  R0
	ST   Z+,R0
	ST   Z,R0
	.ENDM

	.MACRO __CLRD1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	CLR  R0
	ST   Z+,R0
	ST   Z+,R0
	ST   Z+,R0
	ST   Z,R0
	.ENDM

	.MACRO __PUTB2SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z,R26
	.ENDM

	.MACRO __PUTW2SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z+,R26
	ST   Z,R27
	.ENDM

	.MACRO __PUTD2SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z+,R26
	ST   Z+,R27
	ST   Z+,R24
	ST   Z,R25
	.ENDM

	.MACRO __PUTBSRX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z,R@1
	.ENDM

	.MACRO __PUTWSRX
	MOVW R30,R28
	SUBI R30,LOW(-@2)
	SBCI R31,HIGH(-@2)
	ST   Z+,R@0
	ST   Z,R@1
	.ENDM

	.MACRO __PUTB1SNX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SNX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SNX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X+,R31
	ST   X+,R22
	ST   X,R23
	.ENDM

	.MACRO __MULBRR
	MULS R@0,R@1
	MOVW R30,R0
	.ENDM

	.MACRO __MULBRRU
	MUL  R@0,R@1
	MOVW R30,R0
	.ENDM

	.MACRO __MULBRR0
	MULS R@0,R@1
	.ENDM

	.MACRO __MULBRRU0
	MUL  R@0,R@1
	.ENDM

	.MACRO __MULBNWRU
	LDI  R26,@2
	MUL  R26,R@0
	MOVW R30,R0
	MUL  R26,R@1
	ADD  R31,R0
	.ENDM

	.CSEG
	.ORG 0

	.INCLUDE "test.vec"
	.INCLUDE "test.inc"

__RESET:
	CLI
	CLR  R30
	OUT  EECR,R30

;INTERRUPT VECTORS ARE PLACED
;AT THE START OF FLASH
	LDI  R31,1
	OUT  MCUCR,R31
	OUT  MCUCR,R30

;DISABLE WATCHDOG
	LDI  R31,0x18
	WDR
	IN   R26,MCUSR
	CBR  R26,8
	OUT  MCUSR,R26
	STS  WDTCSR,R31
	STS  WDTCSR,R30

;CLEAR R2-R14
	LDI  R24,13
	LDI  R26,2
	CLR  R27
__CLEAR_REG:
	ST   X+,R30
	DEC  R24
	BRNE __CLEAR_REG

;CLEAR SRAM
	LDI  R24,LOW(0x400)
	LDI  R25,HIGH(0x400)
	LDI  R26,LOW(0x100)
	LDI  R27,HIGH(0x100)
__CLEAR_SRAM:
	ST   X+,R30
	SBIW R24,1
	BRNE __CLEAR_SRAM

;GLOBAL VARIABLES INITIALIZATION
	LDI  R30,LOW(__GLOBAL_INI_TBL*2)
	LDI  R31,HIGH(__GLOBAL_INI_TBL*2)
__GLOBAL_INI_NEXT:
	LPM  R24,Z+
	LPM  R25,Z+
	SBIW R24,0
	BREQ __GLOBAL_INI_END
	LPM  R26,Z+
	LPM  R27,Z+
	LPM  R0,Z+
	LPM  R1,Z+
	MOVW R22,R30
	MOVW R30,R0
__GLOBAL_INI_LOOP:
	LPM  R0,Z+
	ST   X+,R0
	SBIW R24,1
	BRNE __GLOBAL_INI_LOOP
	MOVW R30,R22
	RJMP __GLOBAL_INI_NEXT
__GLOBAL_INI_END:

;GPIOR0-GPIOR2 INITIALIZATION
	LDI  R30,__GPIOR0_INIT
	OUT  GPIOR0,R30
	LDI  R30,__GPIOR1_INIT
	OUT  GPIOR1,R30
	LDI  R30,__GPIOR2_INIT
	OUT  GPIOR2,R30

;STACK POINTER INITIALIZATION
	LDI  R30,LOW(0x4FF)
	OUT  SPL,R30
	LDI  R30,HIGH(0x4FF)
	OUT  SPH,R30

;DATA STACK POINTER INITIALIZATION
	LDI  R28,LOW(0x22C)
	LDI  R29,HIGH(0x22C)

	RJMP _main

	.ESEG
	.ORG 0
	.DB  0 ; FIRST EEPROM LOCATION NOT USED, SEE ATMEL ERRATA SHEETS

	.DSEG
	.ORG 0x22C
;       1 // ============================ Atmega88 CPU ׽Ʈ α׷ ===================
;       2 //  CPU : ATmega88-20M
;       3 //     ¥ : 2008-
;       4 //      : Ver1.0
;       5 //    : www.cpuplaza.com
;       6 // Ϸ : CodeVisionAVR
;       7 //      : serial 19200,N,8,1
;       8 // ----------------------------------------------------------------------------
;       9 // ⺻ 
;      10 #include <mega88.h>						// CPU  
;      11 
;      12 #include <stdio.h>
;      13 #include <stdlib.h>
;      14 #include <ctype.h>
;      15 #include <float.h>
;      16 
;      17 //  
;      18 #include "cpusetup.inc"						// cpu  ͷƮ  ƾ
;      19 // =================================== CPUʱȭ ͷƮ ===================
;      20 //      : CPU  ϰ ͷƮ  ƾ .
;      21 // ----------------------------------------------------------------------------
;      22 //   
;      23 #define RXB8 1
;      24 #define TXB8 0
;      25 #define UPE 2
;      26 #define OVR 3
;      27 #define FE 4
;      28 #define UDRE 5
;      29 #define RXC 7
;      30 
;      31 #define FRAMING_ERROR (1<<FE)
;      32 #define PARITY_ERROR (1<<UPE)
;      33 #define DATA_OVERRUN (1<<OVR)
;      34 #define DATA_REGISTER_EMPTY (1<<UDRE)
;      35 #define RX_COMPLETE (1<<RXC)
;      36 
;      37 //  
;      38 char com1_rx_data,com1_rx_eflg = 0;				//   ͷƮ  /÷
;      39 
;      40 int timer0_cnt = 0;						// Ÿ̸0 ͷƮ  ī
;      41 int timer1_cnt = 0;						// Ÿ̸1 ͷƮ  ī
;      42 int timer2_cnt = 0;						// Ÿ̸2 ͷƮ  ī
;      43 
;      44 int exint0_flg = 0;						// EXINT0 ͷƮ  ÷
;      45 int exint1_flg = 0;						// EXINT1 ͷƮ  ÷
;      46 
;      47 unsigned int adc_int_data = 0;					// ADC ͷƮ  
_adc_int_data:
	.BYTE 0x2
;      48 int adc_int_ch = 0;						// ADC CH ͷƮ 
_adc_int_ch:
	.BYTE 0x2
;      49 int adc_int_flg = 0;						// ADC ͷƮ  ÷
_adc_int_flg:
	.BYTE 0x2
;      50 
;      51 // ===================================== CPUʱȭ ============================
;      52 // [μ] void
;      53 // ----------------------------------------------------------------------------
;      54 void cpu_setup(void)
;      55 {

	.CSEG
_cpu_setup:
;      56 // Crystal Oscillator division factor: 1
;      57 #pragma optsize-
;      58 	CLKPR=0x80;
	LDI  R30,LOW(128)
	STS  97,R30
;      59 	CLKPR=0x00;
	LDI  R30,LOW(0)
	STS  97,R30
;      60 #ifdef _OPTIMIZE_SIZE_
;      61 #pragma optsize+
;      62 #endif
;      63 
;      64 // PortB 
;      65 	PORTB=0x00;						// Ʈ  reg
	RCALL SUBOPT_0x0
;      66 	DDRB=0x00;						// Ʈ  reg(0Է,1)
;      67 
;      68 // PortC 
;      69 	PORTC=0x00;						// Ʈ  reg
;      70 	DDRC=0x00;                                              // Ʈ  reg(0Է,1)
;      71 
;      72 // PortD 
;      73 	PORTD=0x00;						// Ʈ  reg
;      74 	DDRD=0x00;                                              // Ʈ  reg(0Է,1)
;      75 
;      76 // Timer/Counter0 
;      77         TCCR0A=0x00;
	RCALL SUBOPT_0x1
;      78         TCCR0B=0x00;
	RCALL SUBOPT_0x2
;      79         TCNT0=0x00;
;      80         OCR0A=0x00;
	RCALL SUBOPT_0x3
;      81         OCR0B=0x00;
;      82 
;      83 // Timer/Counter1 
;      84 	TCCR1A=0x00;
	RCALL SUBOPT_0x4
;      85 	TCCR1B=0x00;
	RCALL SUBOPT_0x5
;      86 	TCNT1H=0x00;
;      87 	TCNT1L=0x00;
;      88 	ICR1H=0x00;
;      89 	ICR1L=0x00;
;      90 	OCR1AH=0x00;
;      91 	OCR1AL=0x00;
;      92 	OCR1BH=0x00;
;      93 	OCR1BL=0x00;
;      94 
;      95 // Timer/Counter2 
;      96 	ASSR=0x00;
	RCALL SUBOPT_0x6
;      97 	TCCR2A=0x00;
;      98 	TCCR2B=0x00;
	RCALL SUBOPT_0x7
;      99 	TCNT2=0x00;
;     100 	OCR2A=0x00;
;     101 	OCR2B=0x00;
;     102 
;     103 // External Interrupt(s) 
;     104 // INT0: Off
;     105 // INT1: Off
;     106 	EICRA=0x00;
	RCALL SUBOPT_0x8
;     107 	EIMSK=0x00;
;     108 	EIFR=0x00;
;     109 	PCICR=0x00;
;     110 
;     111 // Timer(s)/Counter(s) Interrupt(s) 
;     112 	TIMSK0=0x00;
	LDI  R30,LOW(0)
	RCALL SUBOPT_0x9
;     113 	TIMSK1=0x00;
	LDI  R30,LOW(0)
	STS  111,R30
;     114 	TIMSK2=0x00;
	STS  112,R30
;     115 
;     116 //  ʱȭ
;     117 // 19200Bps, 8Data, 1 Stop, No Parity
;     118 	UCSR0A=0x00;
	STS  192,R30
;     119 	UCSR0B=0x98;
	LDI  R30,LOW(152)
	STS  193,R30
;     120 	UCSR0C=0x06;
	LDI  R30,LOW(6)
	STS  194,R30
;     121 	UBRR0H=0x00;
	LDI  R30,LOW(0)
	STS  197,R30
;     122 	UBRR0L=0x40;
	LDI  R30,LOW(64)
	STS  196,R30
;     123 
;     124 // Analog Comparator 
;     125 	ACSR=0x80;
	LDI  R30,LOW(128)
	OUT  0x30,R30
;     126 	ADCSRB=0x00;
	LDI  R30,LOW(0)
	STS  123,R30
;     127 
;     128 // Global enable interrupts
;     129 #asm("sei")
	sei
;     130 }
	RET
;     131 
;     132 // ================================  ͷƮ =============================
;     133 // [μ] void
;     134 // ----------------------------------------------------------------------------
;     135 #pragma savereg-
;     136 interrupt [USART_RXC] void uart_rx_isr(void)
;     137 {
_uart_rx_isr:
;     138 char status,data;
;     139 #asm
;     140 	push r26
	push r26
;     141 	push r27
	push r27
;     142 	push r30
	push r30
;     143 	push r31
	push r31
;     144 	in   r26,sreg
	in   r26,sreg
;     145 	push r26
	push r26
;     146 #endasm
;     147 
;     148 	status = UCSR0A;
	RCALL __SAVELOCR2
;	status -> R17
;	data -> R16
	LDS  R17,192
;     149 	data = UDR0;
	LDS  R16,198
;     150 	if((status & (FRAMING_ERROR | PARITY_ERROR | DATA_OVERRUN))==0){
	MOV  R30,R17
	ANDI R30,LOW(0x1C)
	BRNE _0x3
;     151 		com1_rx_data = data;
	MOV  R3,R16
;     152 		com1_rx_eflg = 1;
	LDI  R30,LOW(1)
	MOV  R2,R30
;     153 	}
;     154 
;     155 #asm
_0x3:
;     156 	pop  r26
	pop  r26
;     157 	out  sreg,r26
	out  sreg,r26
;     158 	pop  r31
	pop  r31
;     159 	pop  r30
	pop  r30
;     160 	pop  r27
	pop  r27
;     161 	pop  r26
	pop  r26
;     162 #endasm
;     163 }
	RCALL __LOADLOCR2P
	RETI
;     164 #pragma savereg+
;     165 
;     166 // ========================== TIMER0 overflow ͷƮ ========================
;     167 // [μ] void
;     168 // [] 20,000,000 / 1024 / 195 =  1 / 100.1602564 = 9.9984ms
;     169 // ----------------------------------------------------------------------------
;     170 interrupt [TIM0_OVF] void timer0_ovf_isr(void)
;     171 {
_timer0_ovf_isr:
	RCALL SUBOPT_0xA
;     172 	TCNT0 = 60;						// 255-195 = 60
	LDI  R30,LOW(60)
	OUT  0x26,R30
;     173 	timer0_cnt++;						// Ÿ̸0 ī
	MOVW R30,R4
	ADIW R30,1
	MOVW R4,R30
;     174 }
	RCALL SUBOPT_0xB
	RETI
;     175 
;     176 // ========================== TIMER1 overflow ͷƮ ========================
;     177 // [μ] void
;     178 // [] 20,000,000 / 64 / 3120 =  1 / 100.0 = 9.9984ms
;     179 // ----------------------------------------------------------------------------
;     180 interrupt [TIM1_OVF] void timer1_ovf_isr(void)
;     181 {
_timer1_ovf_isr:
	RCALL SUBOPT_0xA
;     182 	TCNT1H = 0xf3;						// 65535 - 3120 = 62415
	RCALL SUBOPT_0xC
;     183 	TCNT1L = 0xcf;
;     184 	timer1_cnt++;						// Ÿ̸1 ī
	MOVW R30,R6
	ADIW R30,1
	MOVW R6,R30
;     185 }
	RCALL SUBOPT_0xB
	RETI
;     186 
;     187 // ========================== TIMER2 overflow ͷƮ ========================
;     188 // [μ] void
;     189 // [] 20,000,000 / 1024 / 156 =  1 / 100.1602564 = 9.9984ms
;     190 // ----------------------------------------------------------------------------
;     191 interrupt [TIM2_OVF] void timer2_ovf_isr(void)
;     192 {
_timer2_ovf_isr:
	RCALL SUBOPT_0xA
;     193 	TCNT2 = 60;						// 255-195 = 60
	LDI  R30,LOW(60)
	STS  178,R30
;     194 	timer2_cnt++;						// Ÿ̸2 ī
	MOVW R30,R8
	ADIW R30,1
	MOVW R8,R30
;     195 }
	RCALL SUBOPT_0xB
	RETI
;     196 
;     197 // ========================== ܺ INT0 ͷƮ ==============================
;     198 // [μ] void
;     199 // ----------------------------------------------------------------------------
;     200 interrupt [EXT_INT0] void ext_int0_isr(void)
;     201 {
_ext_int0_isr:
	RCALL SUBOPT_0xD
;     202 	exint0_flg = 1;						// EXINT0 ÷ ON
	MOVW R10,R30
;     203 }
	LD   R31,Y+
	LD   R30,Y+
	RETI
;     204 
;     205 // ========================== ܺ INT1 ͷƮ ==============================
;     206 // [μ] void
;     207 // ----------------------------------------------------------------------------
;     208 interrupt [EXT_INT1] void ext_int1_isr(void)
;     209 {
_ext_int1_isr:
	RCALL SUBOPT_0xD
;     210 	exint1_flg = 1;						// EXINT1 ÷ ON
	MOVW R12,R30
;     211 }
	LD   R31,Y+
	LD   R30,Y+
	RETI
;     212 
;     213 // =============================== ADC ͷƮ ===============================
;     214 // [μ] void
;     215 // ----------------------------------------------------------------------------
;     216 interrupt [ADC_INT] void adc_isr(void)
;     217 {
_adc_isr:
	ST   -Y,R30
	ST   -Y,R31
;     218 	adc_int_data = ADCW;					// ADC
	RCALL SUBOPT_0xE
	STS  _adc_int_data,R30
	STS  _adc_int_data+1,R31
;     219 	adc_int_flg = 1;					// ADC Ϸ ÷ 
	LDI  R30,LOW(1)
	LDI  R31,HIGH(1)
	STS  _adc_int_flg,R30
	STS  _adc_int_flg+1,R31
;     220 }
	LD   R31,Y+
	LD   R30,Y+
	RETI
;     221 
;     222 // Լ 
;     223 void main_menu_disp(void);					//  ޴ ǥ
;     224 void cpu_ioport_output(void);					// CPU PORT I/O ׽Ʈ
;     225 void timer0_test(void);						// TIMER0 TEST
;     226 void timer1_test(void);						// TIMER1 TEST
;     227 void timer2_test(void);						// TIMER2 TEST
;     228 void exint_test(void);						// EXINT0,1 TEST
;     229 void ad_polling_test(void);					// A/D   TEST
;     230 unsigned int ad_read(unsigned char adc_input);			// A/D  ( )
;     231 void ad_interrupt_test(void);					// A/D ͷƮ  TEST
;     232 void ad_start(unsigned char adc_input);				// AD  (ͷƮ )
;     233 void eeprom_test(void);						// EEPROM TEST
;     234 void EEPROM_write(int addr,unsigned char data);			// EEPROM  
;     235 unsigned char EEPROM_read(int addr);				// EEPROM  
;     236 
;     237 void urx_string(char buff[]);					// Ʈ 
;     238 long atoh(char buff[]);						// ASCII TO HEX 
;     239 
;     240 //  
;     241 
;     242 // ===============================  α׷ ==============================
;     243 // [μ]: void
;     244 // ---------------------------------------------------------------------------
;     245 void main(void)
;     246 {
_main:
;     247 	cpu_setup();						// cpuʱȭ
	RCALL _cpu_setup
;     248 	main_menu_disp();					//  ޴ ǥ
	RCALL _main_menu_disp
;     249 	while(1){						// Place your code here
_0x4:
;     250 		if(com1_rx_eflg){				// COM1  ˻
	TST  R2
	BREQ _0x7
;     251 			if(com1_rx_data == '1') cpu_ioport_output();// CPU I/O PORT TEST
	RCALL SUBOPT_0xF
	BRNE _0x8
	RCALL _cpu_ioport_output
;     252 			else if(com1_rx_data == '2') timer0_test(); // TIMER0 TEST
	RJMP _0x9
_0x8:
	RCALL SUBOPT_0x10
	BRNE _0xA
	RCALL _timer0_test
;     253 			else if(com1_rx_data == '3') timer1_test(); // TIMER1 TEST
	RJMP _0xB
_0xA:
	LDI  R30,LOW(51)
	CP   R30,R3
	BRNE _0xC
	RCALL _timer1_test
;     254 			else if(com1_rx_data == '4') timer2_test(); // TIMER2 TEST
	RJMP _0xD
_0xC:
	LDI  R30,LOW(52)
	CP   R30,R3
	BRNE _0xE
	RCALL _timer2_test
;     255 			else if(com1_rx_data == '5') exint_test();  // EXINT0,1 TEST
	RJMP _0xF
_0xE:
	LDI  R30,LOW(53)
	CP   R30,R3
	BRNE _0x10
	RCALL _exint_test
;     256 			else if(com1_rx_data == '6') ad_polling_test();// A/D POLLING TEST
	RJMP _0x11
_0x10:
	LDI  R30,LOW(54)
	CP   R30,R3
	BRNE _0x12
	RCALL _ad_polling_test
;     257 			else if(com1_rx_data == '7') ad_interrupt_test(); // A/D POLLING TEST
	RJMP _0x13
_0x12:
	LDI  R30,LOW(55)
	CP   R30,R3
	BRNE _0x14
	RCALL _ad_interrupt_test
;     258 			else if(com1_rx_data == '8') eeprom_test(); // EEPROM TEST
	RJMP _0x15
_0x14:
	RCALL SUBOPT_0x11
	BRNE _0x16
	RCALL _eeprom_test
;     259 			else putchar(com1_rx_data);
	RJMP _0x17
_0x16:
	RCALL SUBOPT_0x12
;     260 			com1_rx_eflg = 0;
_0x17:
_0x15:
_0x13:
_0x11:
_0xF:
_0xD:
_0xB:
_0x9:
	CLR  R2
;     261 		}
;     262 	}
_0x7:
	RJMP _0x4
;     263 }
_0x18:
	RJMP _0x18
;     264 
;     265 // =====================================  ޴ ǥ =======================
;     266 // [μ]: void
;     267 // ---------------------------------------------------------------------------
;     268 void main_menu_disp(void)
;     269 {
_main_menu_disp:
;     270 	printf("\r\n");
	RCALL SUBOPT_0x13
;     271 	printf("============== MAIN MENU =============\r\n");
	__POINTW1FN _0,3
	RCALL SUBOPT_0x14
;     272 	printf("- 1  : CPU I/O PORT TEST              \r\n");
	__POINTW1FN _0,44
	RCALL SUBOPT_0x14
;     273 	printf("- 2  : TIMER0 TEST                    \r\n");
	__POINTW1FN _0,85
	RCALL SUBOPT_0x14
;     274 	printf("- 3  : TIMER1 TEST                    \r\n");
	__POINTW1FN _0,126
	RCALL SUBOPT_0x14
;     275 	printf("- 4  : TIMER2 TEST                    \r\n");
	__POINTW1FN _0,167
	RCALL SUBOPT_0x14
;     276 	printf("- 5  : EXINT0,1 TEST                  \r\n");
	__POINTW1FN _0,208
	RCALL SUBOPT_0x14
;     277 	printf("- 6  : A/D POLLING   TEST             \r\n");
	__POINTW1FN _0,249
	RCALL SUBOPT_0x14
;     278 	printf("- 7  : A/D INTERRUPT TEST             \r\n");
	__POINTW1FN _0,290
	RCALL SUBOPT_0x14
;     279 	printf("- 8  : EEPROM TEST                    \r\n");
	__POINTW1FN _0,331
	RCALL SUBOPT_0x14
;     280 	printf("-------------- CPUPLAZA --------------\r\n");
	__POINTW1FN _0,372
	RCALL SUBOPT_0x14
;     281 }
	RET
;     282 
;     283 // ============================== CPU_IO TEST =================================
;     284 // [μ]: void
;     285 // ----------------------------------------------------------------------------
;     286 void cpu_ioport_output(void)
;     287 {
_cpu_ioport_output:
;     288 int out_cnt,exit_flg = 0;
;     289 
;     290 	printf("=========== CPU I/O PORT TEST =========\r\n");
	RCALL SUBOPT_0x15
;	out_cnt -> R16,R17
;	exit_flg -> R18,R19
	__POINTW1FN _0,413
	RCALL SUBOPT_0x14
;     291 	printf("- 0  : TOP menu                        \r\n");
	RCALL SUBOPT_0x16
;     292 	printf("---------------------------------------\r\n");
	RCALL SUBOPT_0x17
;     293 // CPU PORT   
;     294 // PORTB[0..5] : OUT
;     295 	PORTB=0x3f;						// Ʈ  reg
	LDI  R30,LOW(63)
	OUT  0x5,R30
;     296 	DDRB=0x3f;						// Ʈ  reg(0Է,1)
	OUT  0x4,R30
;     297 // PORTC[0..5] : OUT
;     298 	PORTC=0x3f;						// Ʈ  reg
	OUT  0x8,R30
;     299 	DDRC=0x3f;						// Ʈ  reg(0Է,1)
	OUT  0x7,R30
;     300 // PORTD[2..7] : OUT
;     301 	PORTD=0xfc;						// Ʈ  reg
	LDI  R30,LOW(252)
	OUT  0xB,R30
;     302 	DDRD=0xfc;						// Ʈ  reg(0Է,1)
	OUT  0xA,R30
;     303 
;     304 // LED  Ÿ Timer/Counter0 (Overflow) 9.9984ms
;     305 	TCCR0A = 0x00;
	RCALL SUBOPT_0x1
;     306 	TCCR0B = 0x05;						// system clock,20,000,000 / 1024 = 19.531Khz
	RCALL SUBOPT_0x18
;     307 	TCNT0 = 60;						// 255-195 = 60
;     308 	OCR0A=0x00;
;     309 	OCR0B=0x00;
;     310 	TIMSK0 |= 0x01;						// TIMER0 ͷƮ 㰡
	RCALL SUBOPT_0x19
	RCALL SUBOPT_0x1A
;     311 
;     312 	timer0_cnt = 0;						// TIMER0 ͷƮ ī Ŭ
;     313 	out_cnt = 0;
	__GETWRN 16,17,0
;     314 	com1_rx_eflg = 0;
	CLR  R2
;     315 	while(exit_flg == 0){
_0x19:
	MOV  R0,R18
	OR   R0,R19
	BREQ PC+2
	RJMP _0x1B
;     316 		if(com1_rx_eflg){				// COM1  ˻
	TST  R2
	BREQ _0x1C
;     317 			if(com1_rx_data == '0') exit_flg = 1;	//  ޴ 
	RCALL SUBOPT_0x1B
	BRNE _0x1D
	__GETWRN 18,19,1
;     318 			else putchar(com1_rx_data);		// ݼ
	RJMP _0x1E
_0x1D:
	RCALL SUBOPT_0x12
;     319 			com1_rx_eflg = 0;
_0x1E:
	CLR  R2
;     320 		}
;     321 		if(timer0_cnt >= 50){				// 500ms  
_0x1C:
	LDI  R30,LOW(50)
	LDI  R31,HIGH(50)
	CP   R4,R30
	CPC  R5,R31
	BRGE PC+2
	RJMP _0x1F
;     322 			if(out_cnt >= 0 && out_cnt <= 5) PORTB = ~(1 << out_cnt);// PORTB (ش Ʈ 0)
	SUBI R16,0
	SBCI R17,0
	BRLT _0x21
	__CPWRN 16,17,6
	BRLT _0x22
_0x21:
	RJMP _0x20
_0x22:
	RCALL SUBOPT_0x1C
	RCALL SUBOPT_0x1D
	OUT  0x5,R30
;     323 			else if(out_cnt >= 6 && out_cnt <= 11){	// PORTC 
	RJMP _0x23
_0x20:
	__CPWRN 16,17,6
	BRLT _0x25
	__CPWRN 16,17,12
	BRLT _0x26
_0x25:
	RJMP _0x24
_0x26:
;     324 				if(out_cnt == 6) PORTB = 0x3f;	// PORTB CLEAR
	LDI  R30,LOW(6)
	LDI  R31,HIGH(6)
	CP   R30,R16
	CPC  R31,R17
	BRNE _0x27
	LDI  R30,LOW(63)
	OUT  0x5,R30
;     325 				PORTC = ~(1 << (out_cnt-6));	// PORTC (ش Ʈ 0)
_0x27:
	RCALL SUBOPT_0x1C
	SBIW R30,6
	RCALL SUBOPT_0x1D
	OUT  0x8,R30
;     326 			}
;     327 			else if(out_cnt >= 12 && out_cnt <= 17){// PORTD 
	RJMP _0x28
_0x24:
	__CPWRN 16,17,12
	BRLT _0x2A
	__CPWRN 16,17,18
	BRLT _0x2B
_0x2A:
	RJMP _0x29
_0x2B:
;     328 				if(out_cnt == 12) PORTC = 0x3f;	// PORTC CLEAR
	LDI  R30,LOW(12)
	LDI  R31,HIGH(12)
	CP   R30,R16
	CPC  R31,R17
	BRNE _0x2C
	LDI  R30,LOW(63)
	OUT  0x8,R30
;     329 				PORTD = ~(4 << (out_cnt-12));	// PORTD (ش Ʈ 0)
_0x2C:
	RCALL SUBOPT_0x1C
	SBIW R30,12
	LDI  R26,LOW(4)
	LDI  R27,HIGH(4)
	RCALL __LSLW12
	COM  R30
	COM  R31
	OUT  0xB,R30
;     330 			}
;     331 			out_cnt++;				//  ġ ī 
_0x29:
_0x28:
_0x23:
	__ADDWRN 16,17,1
;     332 			if(out_cnt >= 19) out_cnt = 0;		//  ġ ʰ ˻
	__CPWRN 16,17,19
	BRLT _0x2D
	__GETWRN 16,17,0
;     333 			if(out_cnt == 0){			//  ü ʱȭ
_0x2D:
	RCALL SUBOPT_0x1E
	BRNE _0x2E
;     334 				PORTB = 0x3f;
	LDI  R30,LOW(63)
	OUT  0x5,R30
;     335 				PORTC = 0x3f;
	OUT  0x8,R30
;     336 				PORTD = 0xfc;
	LDI  R30,LOW(252)
	OUT  0xB,R30
;     337 			}
;     338 			timer0_cnt = 0;
_0x2E:
	CLR  R4
	CLR  R5
;     339 		}
;     340 	}
_0x1F:
	RJMP _0x19
_0x1B:
;     341 
;     342 // Timer/Counter0 
;     343 	TCCR0A = 0x00;
	RCALL SUBOPT_0x1
;     344 	TCCR0B = 0x00;
	RCALL SUBOPT_0x2
;     345 	TCNT0 = 0;
;     346 	TIMSK0 &= 0xfe;						// TIMER0 ͷƮ 
	RCALL SUBOPT_0x19
	ANDI R30,0xFE
	RCALL SUBOPT_0x9
;     347 
;     348 // CPU PORT ʱⰪ  
;     349 // PORTB
;     350 	PORTB=0x00;						// Ʈ  reg
	RCALL SUBOPT_0x0
;     351 	DDRB=0x00;						// Ʈ  reg(0Է,1)
;     352 // PORTC
;     353 	PORTC=0x00;						// Ʈ  reg
;     354 	DDRC=0x00;						// Ʈ  reg(0Է,1)
;     355 // PORTD
;     356 	PORTD=0x00;						// Ʈ  reg
;     357 	DDRD=0x00;						// Ʈ  reg(0Է,1)
;     358 
;     359 	main_menu_disp();					//  ޴ ǥ
	RCALL _main_menu_disp
;     360 }
	RJMP _0x133
;     361 
;     362 // ============================== TIMER0 TEST =================================
;     363 // [μ]: void
;     364 // ----------------------------------------------------------------------------
;     365 void timer0_test(void)
;     366 {
_timer0_test:
;     367 int exit_flg = 0;
;     368 
;     369 	printf("================ TIMER0 TEST ==============\r\n");
	RCALL SUBOPT_0x1F
;	exit_flg -> R16,R17
	__POINTW1FN _0,539
	RCALL SUBOPT_0x14
;     370 	printf("- 0  : TOP menu                            \r\n");
	__POINTW1FN _0,585
	RCALL SUBOPT_0x14
;     371 	printf("- interrupt    : TIMER0 Overfow 9.9984ms   \r\n");
	__POINTW1FN _0,631
	RCALL SUBOPT_0x14
;     372 	printf("- message disp : 9.9984ms * 100 = 999.84ms \r\n");
	__POINTW1FN _0,677
	RCALL SUBOPT_0x14
;     373 	printf("-------------------------------------------\r\n");
	__POINTW1FN _0,723
	RCALL SUBOPT_0x14
;     374 
;     375 // Timer/Counter0 (Overflow)
;     376 	TCCR0A = 0x00;
	RCALL SUBOPT_0x1
;     377 	TCCR0B = 0x05;						// system clock,20,000,000 / 1024 = 19.531Khz
	RCALL SUBOPT_0x18
;     378 	TCNT0 = 60;						// 255-195 = 60
;     379 	OCR0A = 0x00;
;     380 	OCR0B = 0x00;
;     381 	TIMSK0 |= 0x01;						// TIMER0 ͷƮ 㰡
	RCALL SUBOPT_0x19
	RCALL SUBOPT_0x1A
;     382 
;     383 	timer0_cnt = 0;						// TIMER0 ͷƮ ī Ŭ
;     384 	com1_rx_eflg = 0;
	CLR  R2
;     385 	while(exit_flg == 0){
_0x2F:
	RCALL SUBOPT_0x1E
	BRNE _0x31
;     386 		if(com1_rx_eflg){				// COM1  ˻
	TST  R2
	BREQ _0x32
;     387 			if(com1_rx_data == '0') exit_flg = 1;	//  ޴ 
	RCALL SUBOPT_0x1B
	BRNE _0x33
	RCALL SUBOPT_0x20
;     388 			else putchar(com1_rx_data);		// ݼ
	RJMP _0x34
_0x33:
	RCALL SUBOPT_0x12
;     389 			com1_rx_eflg = 0;
_0x34:
	CLR  R2
;     390 		}
;     391 		if(timer0_cnt >= 100){				// 999.84ms üũ
_0x32:
	LDI  R30,LOW(100)
	LDI  R31,HIGH(100)
	CP   R4,R30
	CPC  R5,R31
	BRLT _0x35
;     392 			printf("TIMER0 Overflow Interrupt\r\n");
	__POINTW1FN _0,769
	RCALL SUBOPT_0x14
;     393 			timer0_cnt = 0;
	CLR  R4
	CLR  R5
;     394 		}
;     395 	}
_0x35:
	RJMP _0x2F
_0x31:
;     396 
;     397 // Timer/Counter0 
;     398 	TCCR0A = 0x00;
	RCALL SUBOPT_0x1
;     399 	TCCR0B = 0x00;
	RCALL SUBOPT_0x2
;     400 	TCNT0 = 0;
;     401 	OCR0A = 0x00;
	RCALL SUBOPT_0x3
;     402 	OCR0B = 0x00;
;     403 	TIMSK0 &= 0xfe;						// TIMER0 ͷƮ 
	RCALL SUBOPT_0x19
	ANDI R30,0xFE
	RCALL SUBOPT_0x9
;     404 
;     405 	main_menu_disp();					//  ޴ ǥ
	RCALL _main_menu_disp
;     406 }
	RJMP _0x132
;     407 
;     408 // ============================== TIMER1 TEST =================================
;     409 // [μ]: void
;     410 // ----------------------------------------------------------------------------
;     411 void timer1_test(void)
;     412 {
_timer1_test:
;     413 int exit_flg = 0;
;     414 
;     415 	printf("============== TIMER1 TEST ============\r\n");
	RCALL SUBOPT_0x1F
;	exit_flg -> R16,R17
	__POINTW1FN _0,797
	RCALL SUBOPT_0x14
;     416 	printf("- 0  : TOP menu                        \r\n");
	RCALL SUBOPT_0x16
;     417 	printf("- interrupt   : TIMER1 Overfow 9.9984ms\r\n");
	__POINTW1FN _0,839
	RCALL SUBOPT_0x14
;     418 	printf("- message disp: 9.998ms * 100 = 90.998s\r\n");
	__POINTW1FN _0,881
	RCALL SUBOPT_0x14
;     419 	printf("---------------------------------------\r\n");
	RCALL SUBOPT_0x17
;     420 
;     421 // Timer/Counter1 (Overflow)
;     422 	TCCR1A = 0x00;
	RCALL SUBOPT_0x4
;     423 	TCCR1B = 0x03;						// system clock,20,000,000 / 64 = 312.500Khz
	LDI  R30,LOW(3)
	STS  129,R30
;     424 	TCNT1H = 0xf3;						// 65535 - 3120 = 62415
	RCALL SUBOPT_0xC
;     425 	TCNT1L = 0xcf;
;     426 	ICR1H  = 0x00;
	LDI  R30,LOW(0)
	STS  135,R30
;     427 	ICR1L = 0x00;
	STS  134,R30
;     428 	OCR1AH = 0x00;
	STS  137,R30
;     429 	OCR1AL = 0x00;
	STS  136,R30
;     430 	OCR1BH = 0x00;
	STS  139,R30
;     431 	OCR1BL = 0x00;
	STS  138,R30
;     432 	TIMSK1 |= 0x01;						// TIMER1 ͷƮ 㰡
	LDS  R30,111
	ORI  R30,1
	STS  111,R30
;     433 
;     434 	timer1_cnt = 0;						// TIMER1 ͷƮ ī Ŭ
	CLR  R6
	CLR  R7
;     435 	com1_rx_eflg = 0;
	CLR  R2
;     436 	while(exit_flg == 0){					// COM1  ˻
_0x36:
	RCALL SUBOPT_0x1E
	BRNE _0x38
;     437 		if(com1_rx_eflg){
	TST  R2
	BREQ _0x39
;     438 			if(com1_rx_data == '0') exit_flg = 1;	//  ޴ 
	RCALL SUBOPT_0x1B
	BRNE _0x3A
	RCALL SUBOPT_0x20
;     439 			else putchar(com1_rx_data);		// ݼ
	RJMP _0x3B
_0x3A:
	RCALL SUBOPT_0x12
;     440 			com1_rx_eflg = 0;
_0x3B:
	CLR  R2
;     441 		}
;     442 		if(timer1_cnt >= 100){				// 1s üũ
_0x39:
	LDI  R30,LOW(100)
	LDI  R31,HIGH(100)
	CP   R6,R30
	CPC  R7,R31
	BRLT _0x3C
;     443 			printf("TIMER1 Overflow Interrupt\r\n");
	__POINTW1FN _0,923
	RCALL SUBOPT_0x14
;     444 			timer1_cnt = 0;
	CLR  R6
	CLR  R7
;     445 		}
;     446 	}
_0x3C:
	RJMP _0x36
_0x38:
;     447 
;     448 // Timer/Counter1 
;     449 	TCCR1A = 0x00;
	RCALL SUBOPT_0x4
;     450 	TCCR1B = 0x00;
	RCALL SUBOPT_0x5
;     451 	TCNT1H = 0x00;
;     452 	TCNT1L = 0x00;
;     453 	ICR1H  = 0x00;
;     454 	ICR1L = 0x00;
;     455 	OCR1AH = 0x00;
;     456 	OCR1AL = 0x00;
;     457 	OCR1BH = 0x00;
;     458 	OCR1BL = 0x00;
;     459 	TIMSK1 &= 0xfe;						// TIMER1 ͷƮ 
	LDS  R30,111
	ANDI R30,0xFE
	STS  111,R30
;     460 
;     461 	main_menu_disp();					//  ޴ ǥ
	RCALL _main_menu_disp
;     462 }
	RJMP _0x132
;     463 
;     464 // ============================== TIMER2 TEST =================================
;     465 // [μ]: void
;     466 // ----------------------------------------------------------------------------
;     467 void timer2_test(void)
;     468 {
_timer2_test:
;     469 int exit_flg = 0;
;     470 
;     471 	printf("=============== TIMER2 TEST ==============\r\n");
	RCALL SUBOPT_0x1F
;	exit_flg -> R16,R17
	__POINTW1FN _0,951
	RCALL SUBOPT_0x14
;     472 	printf("- 0  : TOP menu                           \r\n");
	__POINTW1FN _0,996
	RCALL SUBOPT_0x14
;     473 	printf("- interrupt    : TIMER0 Overfow 9.9984ms  \r\n");
	__POINTW1FN _0,1041
	RCALL SUBOPT_0x14
;     474 	printf("- message disp : 9.9984ms * 100 = 999.84ms\r\n");
	__POINTW1FN _0,1086
	RCALL SUBOPT_0x14
;     475 	printf("------------------------------------------\r\n");
	__POINTW1FN _0,724
	RCALL SUBOPT_0x14
;     476 
;     477 // Timer/Counter2 (Overflow)
;     478 	ASSR = 0x00;
	RCALL SUBOPT_0x6
;     479 	TCCR2A = 0x00;
;     480 	TCCR2B = 0x07;						// system clock,20,000,000 / 1024 = 19.531Khz
	LDI  R30,LOW(7)
	STS  177,R30
;     481 	TCNT2 = 60;						// 255-195 = 60
	LDI  R30,LOW(60)
	STS  178,R30
;     482 	OCR2A = 0x00;
	LDI  R30,LOW(0)
	STS  179,R30
;     483 	OCR2B = 0x00;
	STS  180,R30
;     484 	TIMSK2 |= 0x01;						// TIMER2 ͷƮ 
	LDS  R30,112
	ORI  R30,1
	STS  112,R30
;     485 
;     486 	timer2_cnt = 0;						// TIMER2 ͷƮ ī Ŭ
	CLR  R8
	CLR  R9
;     487 	com1_rx_eflg = 0;
	CLR  R2
;     488 	while(exit_flg == 0){
_0x3D:
	RCALL SUBOPT_0x1E
	BRNE _0x3F
;     489 		if(com1_rx_eflg){				// COM1  ˻
	TST  R2
	BREQ _0x40
;     490 			if(com1_rx_data == '0') exit_flg = 1;	//  ޴ 
	RCALL SUBOPT_0x1B
	BRNE _0x41
	RCALL SUBOPT_0x20
;     491 			else putchar(com1_rx_data);		// ݼ
	RJMP _0x42
_0x41:
	RCALL SUBOPT_0x12
;     492 			com1_rx_eflg = 0;
_0x42:
	CLR  R2
;     493 		}
;     494 		if(timer2_cnt >= 100){				// 999.84ms üũ
_0x40:
	LDI  R30,LOW(100)
	LDI  R31,HIGH(100)
	CP   R8,R30
	CPC  R9,R31
	BRLT _0x43
;     495 			printf("TIMER2 Overflow Interrupt\r\n");
	__POINTW1FN _0,1131
	RCALL SUBOPT_0x14
;     496 			timer2_cnt = 0;
	CLR  R8
	CLR  R9
;     497 		}
;     498 	}
_0x43:
	RJMP _0x3D
_0x3F:
;     499 
;     500 // Timer/Counter2 
;     501 	ASSR = 0x00;
	RCALL SUBOPT_0x6
;     502 	TCCR2A = 0x00;
;     503 	TCCR2B = 0x00;
	RCALL SUBOPT_0x7
;     504 	TCNT2 = 0x00;
;     505 	OCR2A = 0x00;
;     506 	OCR2B = 0x00;
;     507 	TIMSK2 &= 0xfe;						// TIMER2 ͷƮ 
	LDS  R30,112
	ANDI R30,0xFE
	STS  112,R30
;     508 
;     509 	main_menu_disp();					//  ޴ ǥ
	RCALL _main_menu_disp
;     510 }
	RJMP _0x132
;     511 
;     512 // ============================== EXINT0,1 TEST ===============================
;     513 // [μ]: void
;     514 // ----------------------------------------------------------------------------
;     515 void exint_test(void)
;     516 {
_exint_test:
;     517 int exit_flg = 0;
;     518 
;     519 	printf("============== EXINT0,1 TEST ==========\r\n");
	RCALL SUBOPT_0x1F
;	exit_flg -> R16,R17
	__POINTW1FN _0,1159
	RCALL SUBOPT_0x14
;     520 	printf("- 0  : TOP menu                        \r\n");
	RCALL SUBOPT_0x16
;     521 	printf("- interrupt : INT0 Falling Edge        \r\n");
	__POINTW1FN _0,1201
	RCALL SUBOPT_0x14
;     522 	printf("-             INT1 Falling Edge        \r\n");
	__POINTW1FN _0,1243
	RCALL SUBOPT_0x14
;     523 	printf("---------------------------------------\r\n");
	RCALL SUBOPT_0x17
;     524 
;     525 // External Interrupt(s) 
;     526 // INT0 Mode: Falling Edge
;     527 // INT1 Mode: Falling Edge
;     528 	EICRA=0x0A;
	LDI  R30,LOW(10)
	STS  105,R30
;     529 	EIMSK=0x03;
	LDI  R30,LOW(3)
	OUT  0x1D,R30
;     530 	EIFR=0x03;
	OUT  0x1C,R30
;     531 	PCICR=0x00;
	LDI  R30,LOW(0)
	STS  104,R30
;     532 
;     533 	exint0_flg = exint1_flg = 0;				// EXINT0,1 ͷƮ ÷ Ŭ
	RCALL SUBOPT_0x21
	MOVW R12,R30
	MOVW R10,R30
;     534 	com1_rx_eflg = 0;
	CLR  R2
;     535 	while(exit_flg == 0){
_0x44:
	RCALL SUBOPT_0x1E
	BRNE _0x46
;     536 		if(com1_rx_eflg){				// COM1  ˻
	TST  R2
	BREQ _0x47
;     537 			if(com1_rx_data == '0') exit_flg = 1;	//  ޴ 
	RCALL SUBOPT_0x1B
	BRNE _0x48
	RCALL SUBOPT_0x20
;     538 			else putchar(com1_rx_data);		// ݼ
	RJMP _0x49
_0x48:
	RCALL SUBOPT_0x12
;     539 			com1_rx_eflg = 0;
_0x49:
	CLR  R2
;     540 		}
;     541 		if(exint0_flg){					// EXINT0 ͷƮ ÷ üũ
_0x47:
	MOV  R0,R10
	OR   R0,R11
	BREQ _0x4A
;     542 			printf("EXINT0 Interrupt\r\n");
	__POINTW1FN _0,1285
	RCALL SUBOPT_0x14
;     543 			exint0_flg = 0;
	CLR  R10
	CLR  R11
;     544 		}
;     545 		if(exint1_flg){					// EXINT1 ͷƮ ÷ üũ
_0x4A:
	MOV  R0,R12
	OR   R0,R13
	BREQ _0x4B
;     546 			printf("EXINT1 Interrupt\r\n");
	__POINTW1FN _0,1304
	RCALL SUBOPT_0x14
;     547 			exint1_flg = 0;
	CLR  R12
	CLR  R13
;     548 		}
;     549 	}
_0x4B:
	RJMP _0x44
_0x46:
;     550 
;     551 // External Interrupt(s) 
;     552 	EICRA=0x00;
	RCALL SUBOPT_0x8
;     553 	EIMSK=0x00;
;     554 	EIFR=0x00;
;     555 	PCICR=0x00;
;     556 
;     557 	main_menu_disp();					//  ޴ ǥ
	RCALL _main_menu_disp
;     558 }
	RJMP _0x132
;     559 
;     560 // ============================== A/D POLLING TEST ============================
;     561 // [μ]: void
;     562 // ----------------------------------------------------------------------------
;     563 void ad_polling_test(void)
;     564 {
_ad_polling_test:
;     565 unsigned datau;
;     566 int exit_flg = 0;
;     567 
;     568 	printf("============ A/D POLLING TEST =========\r\n");
	RCALL SUBOPT_0x15
;	datau -> R16,R17
;	exit_flg -> R18,R19
	__POINTW1FN _0,1323
	RCALL SUBOPT_0x14
;     569 	printf("- 0  : TOP menu                        \r\n");
	RCALL SUBOPT_0x16
;     570 	printf("- 1  : CH0 READ                        \r\n");
	__POINTW1FN _0,1365
	RCALL SUBOPT_0x14
;     571 	printf("- 2  : CH1 READ                        \r\n");
	__POINTW1FN _0,1407
	RCALL SUBOPT_0x14
;     572 	printf("- 3  : CH2 READ                        \r\n");
	__POINTW1FN _0,1449
	RCALL SUBOPT_0x14
;     573 	printf("- 4  : CH3 READ                        \r\n");
	__POINTW1FN _0,1491
	RCALL SUBOPT_0x14
;     574 	printf("- 5  : CH4 READ                        \r\n");
	__POINTW1FN _0,1533
	RCALL SUBOPT_0x14
;     575 	printf("- 6  : CH5 READ                        \r\n");
	__POINTW1FN _0,1575
	RCALL SUBOPT_0x14
;     576 	printf("- 7  : CH6 READ                        \r\n");
	__POINTW1FN _0,1617
	RCALL SUBOPT_0x14
;     577 	printf("- 8  : CH7 READ                        \r\n");
	__POINTW1FN _0,1659
	RCALL SUBOPT_0x14
;     578 	printf("---------------------------------------\r\n");
	RCALL SUBOPT_0x17
;     579 
;     580 // ADC initialization 
;     581 // 312.500kHz,AREF
;     582 	DIDR0=0x00;
	RCALL SUBOPT_0x22
;     583 	ADMUX=0x00;
;     584 	ADCSRA=0x86;
	LDI  R30,LOW(134)
	RCALL SUBOPT_0x23
;     585 
;     586 	com1_rx_eflg = 0;
	CLR  R2
;     587 	while(exit_flg == 0){
_0x4C:
	MOV  R0,R18
	OR   R0,R19
	BREQ PC+2
	RJMP _0x4E
;     588 		if(com1_rx_eflg){				// COM1  ˻
	TST  R2
	BRNE PC+2
	RJMP _0x4F
;     589 			if(com1_rx_data == '0') exit_flg = 1;	//  ޴ 
	RCALL SUBOPT_0x1B
	BRNE _0x50
	__GETWRN 18,19,1
;     590 			else if(com1_rx_data == '1') datau = ad_read(0);// CH0 
	RJMP _0x51
_0x50:
	RCALL SUBOPT_0xF
	BRNE _0x52
	LDI  R30,LOW(0)
	RCALL SUBOPT_0x24
;     591 			else if(com1_rx_data == '2') datau = ad_read(1);// CH1 
	RJMP _0x53
_0x52:
	RCALL SUBOPT_0x10
	BRNE _0x54
	LDI  R30,LOW(1)
	RCALL SUBOPT_0x24
;     592 			else if(com1_rx_data == '3') datau = ad_read(2);// CH2 
	RJMP _0x55
_0x54:
	LDI  R30,LOW(51)
	CP   R30,R3
	BRNE _0x56
	LDI  R30,LOW(2)
	RCALL SUBOPT_0x24
;     593 			else if(com1_rx_data == '4') datau = ad_read(3);// CH3 
	RJMP _0x57
_0x56:
	LDI  R30,LOW(52)
	CP   R30,R3
	BRNE _0x58
	LDI  R30,LOW(3)
	RCALL SUBOPT_0x24
;     594 			else if(com1_rx_data == '5') datau = ad_read(4);// CH4 
	RJMP _0x59
_0x58:
	LDI  R30,LOW(53)
	CP   R30,R3
	BRNE _0x5A
	LDI  R30,LOW(4)
	RCALL SUBOPT_0x24
;     595 			else if(com1_rx_data == '6') datau = ad_read(5);// CH5 
	RJMP _0x5B
_0x5A:
	LDI  R30,LOW(54)
	CP   R30,R3
	BRNE _0x5C
	LDI  R30,LOW(5)
	RCALL SUBOPT_0x24
;     596 			else if(com1_rx_data == '7') datau = ad_read(6);// CH6 
	RJMP _0x5D
_0x5C:
	LDI  R30,LOW(55)
	CP   R30,R3
	BRNE _0x5E
	LDI  R30,LOW(6)
	RCALL SUBOPT_0x24
;     597 			else if(com1_rx_data == '8') datau = ad_read(7);// CH7 
	RJMP _0x5F
_0x5E:
	RCALL SUBOPT_0x11
	BRNE _0x60
	LDI  R30,LOW(7)
	RCALL SUBOPT_0x24
;     598 			else putchar(com1_rx_data);		// ݼ
	RJMP _0x61
_0x60:
	RCALL SUBOPT_0x12
;     599 			// A/D  ǥ
;     600 			if(com1_rx_data >= '1' && com1_rx_data <= '8') printf("ADC CH%d > %d\r\n",(com1_rx_data&0x0f)-1,datau);
_0x61:
_0x5F:
_0x5D:
_0x5B:
_0x59:
_0x57:
_0x55:
_0x53:
_0x51:
	LDI  R30,LOW(49)
	CP   R3,R30
	BRLO _0x63
	RCALL SUBOPT_0x11
	BRSH _0x64
_0x63:
	RJMP _0x62
_0x64:
	__POINTW1FN _0,1701
	RCALL SUBOPT_0x25
	MOV  R30,R3
	ANDI R30,LOW(0xF)
	SUBI R30,LOW(1)
	RCALL SUBOPT_0x26
	RCALL SUBOPT_0x1C
	RCALL SUBOPT_0x27
;     601 			com1_rx_eflg = 0;
_0x62:
	CLR  R2
;     602 		}
;     603 	}
_0x4F:
	RJMP _0x4C
_0x4E:
;     604 
;     605 // ADC initialization 
;     606 	DIDR0=0x00;
	RCALL SUBOPT_0x22
;     607 	ADMUX=0x00;
;     608 	ADCSRA=0x00;
	RCALL SUBOPT_0x28
;     609 	ADCSRB&=0xf8;
;     610 
;     611 	main_menu_disp();					//  ޴ ǥ
;     612 }
_0x133:
	RCALL __LOADLOCR4
	ADIW R28,4
	RET
;     613 
;     614 // ============================== A/D POLLING TEST ============================
;     615 // [μ]: unsigned char adc_input
;     616 // ITEM1 : AD CH(0-7)
;     617 // []: A/D 10bit
;     618 // ----------------------------------------------------------------------------
;     619 unsigned int ad_read(unsigned char adc_input)
;     620 {
_ad_read:
;     621 	ADMUX = adc_input;					// ADREF(0) + CH
;	adc_input -> Y+0
	RCALL SUBOPT_0x29
;     622 	ADCSRA |= 0x40;						// AD conversion 
;     623 	while((ADCSRA & 0x10) == 0);				//  Ϸ 
_0x65:
	LDS  R30,122
	ANDI R30,LOW(0x10)
	BREQ _0x65
;     624 	ADCSRA |= 0x10;						// AD ÷ Ŭ
	LDS  R30,122
	ORI  R30,0x10
	RCALL SUBOPT_0x23
;     625 	return ADCW;
	RCALL SUBOPT_0xE
	RJMP _0x130
;     626 }
;     627 
;     628 // ============================== A/D INTERRUPT TEST ==========================
;     629 // [μ]: void
;     630 // ----------------------------------------------------------------------------
;     631 void ad_interrupt_test(void)
;     632 {
_ad_interrupt_test:
;     633 int exit_flg = 0;
;     634 
;     635 	printf("=========== A/D INTEERRUPT TEST =======\r\n");
	RCALL SUBOPT_0x1F
;	exit_flg -> R16,R17
	__POINTW1FN _0,1717
	RCALL SUBOPT_0x14
;     636 	printf("- 0  : TOP menu                        \r\n");
	RCALL SUBOPT_0x16
;     637 	printf("- 1  : CH0 READ                        \r\n");
	__POINTW1FN _0,1365
	RCALL SUBOPT_0x14
;     638 	printf("- 2  : CH1 READ                        \r\n");
	__POINTW1FN _0,1407
	RCALL SUBOPT_0x14
;     639 	printf("- 3  : CH2 READ                        \r\n");
	__POINTW1FN _0,1449
	RCALL SUBOPT_0x14
;     640 	printf("- 4  : CH3 READ                        \r\n");
	__POINTW1FN _0,1491
	RCALL SUBOPT_0x14
;     641 	printf("- 5  : CH4 READ                        \r\n");
	__POINTW1FN _0,1533
	RCALL SUBOPT_0x14
;     642 	printf("- 6  : CH5 READ                        \r\n");
	__POINTW1FN _0,1575
	RCALL SUBOPT_0x14
;     643 	printf("- 7  : CH6 READ                        \r\n");
	__POINTW1FN _0,1617
	RCALL SUBOPT_0x14
;     644 	printf("- 8  : CH7 READ                        \r\n");
	__POINTW1FN _0,1659
	RCALL SUBOPT_0x14
;     645 	printf("---------------------------------------\r\n");
	RCALL SUBOPT_0x17
;     646 
;     647 // ADC initialization 
;     648 // ADC initialization 
;     649 // 312.500kHz,AREF :: ȯ ͷƮ
;     650 	DIDR0=0x00;
	RCALL SUBOPT_0x22
;     651 	ADMUX=0x00;
;     652 	ADCSRA=0x8e;
	LDI  R30,LOW(142)
	RCALL SUBOPT_0x23
;     653 
;     654 	adc_int_flg = 0;					// ADCϷ ͷƮ ÷
	RCALL SUBOPT_0x2A
;     655 	adc_int_ch = 0;						// ADC CH = CH0
	LDI  R30,0
	STS  _adc_int_ch,R30
	STS  _adc_int_ch+1,R30
;     656 	com1_rx_eflg = 0;
	CLR  R2
;     657 	while(exit_flg == 0){
_0x68:
	RCALL SUBOPT_0x1E
	BREQ PC+2
	RJMP _0x6A
;     658 		if(com1_rx_eflg){				// COM1  ˻
	TST  R2
	BREQ _0x6B
;     659 			if(com1_rx_data == '0') exit_flg = 1;	//  ޴ 
	RCALL SUBOPT_0x1B
	BRNE _0x6C
	RCALL SUBOPT_0x20
;     660 			else if(com1_rx_data == '1') ad_start(0);// CH0 
	RJMP _0x6D
_0x6C:
	RCALL SUBOPT_0xF
	BRNE _0x6E
	LDI  R30,LOW(0)
	RCALL SUBOPT_0x2B
;     661 			else if(com1_rx_data == '2') ad_start(1);// CH1 
	RJMP _0x6F
_0x6E:
	RCALL SUBOPT_0x10
	BRNE _0x70
	LDI  R30,LOW(1)
	RCALL SUBOPT_0x2B
;     662 			else if(com1_rx_data == '3') ad_start(2);// CH2 
	RJMP _0x71
_0x70:
	LDI  R30,LOW(51)
	CP   R30,R3
	BRNE _0x72
	LDI  R30,LOW(2)
	RCALL SUBOPT_0x2B
;     663 			else if(com1_rx_data == '4') ad_start(3);// CH3 
	RJMP _0x73
_0x72:
	LDI  R30,LOW(52)
	CP   R30,R3
	BRNE _0x74
	LDI  R30,LOW(3)
	RCALL SUBOPT_0x2B
;     664 			else if(com1_rx_data == '5') ad_start(4);// CH4 
	RJMP _0x75
_0x74:
	LDI  R30,LOW(53)
	CP   R30,R3
	BRNE _0x76
	LDI  R30,LOW(4)
	RCALL SUBOPT_0x2B
;     665 			else if(com1_rx_data == '6') ad_start(5);// CH5 
	RJMP _0x77
_0x76:
	LDI  R30,LOW(54)
	CP   R30,R3
	BRNE _0x78
	LDI  R30,LOW(5)
	RCALL SUBOPT_0x2B
;     666 			else if(com1_rx_data == '7') ad_start(6);// CH6 
	RJMP _0x79
_0x78:
	LDI  R30,LOW(55)
	CP   R30,R3
	BRNE _0x7A
	LDI  R30,LOW(6)
	RCALL SUBOPT_0x2B
;     667 			else if(com1_rx_data == '8') ad_start(7);// CH7 
	RJMP _0x7B
_0x7A:
	RCALL SUBOPT_0x11
	BRNE _0x7C
	LDI  R30,LOW(7)
	RCALL SUBOPT_0x2B
;     668 			else putchar(com1_rx_data);		// ݼ
	RJMP _0x7D
_0x7C:
	RCALL SUBOPT_0x12
;     669 			// A/D  ǥ
;     670 			if(com1_rx_data >= '1' && com1_rx_data <= '8') printf("STAT ADC ");
_0x7D:
_0x7B:
_0x79:
_0x77:
_0x75:
_0x73:
_0x71:
_0x6F:
_0x6D:
	LDI  R30,LOW(49)
	CP   R3,R30
	BRLO _0x7F
	RCALL SUBOPT_0x11
	BRSH _0x80
_0x7F:
	RJMP _0x7E
_0x80:
	__POINTW1FN _0,1759
	RCALL SUBOPT_0x14
;     671 			com1_rx_eflg = 0;
_0x7E:
	CLR  R2
;     672 		}
;     673 		if(adc_int_flg){				// ADC  Ϸ ͷƮ ÷
_0x6B:
	LDS  R30,_adc_int_flg
	LDS  R31,_adc_int_flg+1
	SBIW R30,0
	BREQ _0x81
;     674 			printf("CH%d > %d\r\n",adc_int_ch,adc_int_data);// ADC CH  ǥ
	__POINTW1FN _0,1705
	RCALL SUBOPT_0x25
	LDS  R30,_adc_int_ch
	LDS  R31,_adc_int_ch+1
	RCALL __CWD1
	RCALL __PUTPARD1
	LDS  R30,_adc_int_data
	LDS  R31,_adc_int_data+1
	RCALL SUBOPT_0x27
;     675 			adc_int_flg = 0;
	RCALL SUBOPT_0x2A
;     676 		}
;     677 	}
_0x81:
	RJMP _0x68
_0x6A:
;     678 
;     679 // ADC initialization 
;     680 	DIDR0=0x00;
	RCALL SUBOPT_0x22
;     681 	ADMUX=0x00;
;     682 	ADCSRA=0x00;
	RCALL SUBOPT_0x28
;     683 	ADCSRB&=0xf8;
;     684 
;     685 	main_menu_disp();					//  ޴ ǥ
;     686 }
_0x132:
	RCALL __LOADLOCR2P
	RET
;     687 
;     688 // ============================== A/D POLLING TEST ============================
;     689 // [μ]: unsigned char adc_input
;     690 // ITEM1 : AD CH(0-7)
;     691 // []: A/D 10bit
;     692 // ----------------------------------------------------------------------------
;     693 void ad_start(unsigned char adc_input)
;     694 {
_ad_start:
;     695 	adc_int_ch = adc_input;					// ADC CH 
;	adc_input -> Y+0
	LD   R30,Y
	LDI  R31,0
	STS  _adc_int_ch,R30
	STS  _adc_int_ch+1,R31
;     696 	ADMUX = adc_input;					// ADREF(0) + CH
	RCALL SUBOPT_0x29
;     697 	ADCSRA |= 0x40;						// AD conversion 
;     698 }
	RJMP _0x130
;     699 
;     700 // ================================ EEPROM TEST ===============================
;     701 // [μ]: void
;     702 // ----------------------------------------------------------------------------
;     703 void eeprom_test(void)
;     704 {
_eeprom_test:
;     705 char ch,buff[100],buff1[30],buff2[30],buff3[30];
;     706 unsigned char uch;
;     707 int i,j,cnt,exit_flg = 0;
;     708 unsigned int saddr,ecnt;
;     709 
;     710 	printf("========= INTERNAL EEPROM TEST ========\r\n");
	SBIW R28,63
	SBIW R28,63
	SBIW R28,63
	SBIW R28,9
	LDI  R24,2
	LDI  R26,LOW(4)
	LDI  R27,HIGH(4)
	LDI  R30,LOW(_0x82*2)
	LDI  R31,HIGH(_0x82*2)
	RCALL __INITLOCB
	RCALL __SAVELOCR6
;	ch -> R17
;	buff -> Y+104
;	buff1 -> Y+74
;	buff2 -> Y+44
;	buff3 -> Y+14
;	uch -> R16
;	i -> R18,R19
;	j -> R20,R21
;	cnt -> Y+12
;	exit_flg -> Y+10
;	saddr -> Y+8
;	ecnt -> Y+6
	__POINTW1FN _0,1769
	RCALL SUBOPT_0x14
;     711 	printf("- 0 : TOP menu                         \r\n");
	__POINTW1FN _0,1811
	RCALL SUBOPT_0x14
;     712 	printf("  1 : Read  Data(000-1ffh)             \r\n");
	__POINTW1FN _0,1853
	RCALL SUBOPT_0x14
;     713 	printf("  2 : Write Data(000-1ffh)             \r\n");
	__POINTW1FN _0,1895
	RCALL SUBOPT_0x14
;     714 	printf("---------------------------------------\r\n");
	RCALL SUBOPT_0x17
;     715 
;     716 	com1_rx_eflg = 0;
	CLR  R2
;     717 	while(exit_flg == 0){
_0x83:
	RCALL SUBOPT_0x2C
	SBIW R30,0
	BREQ PC+2
	RJMP _0x85
;     718 		if(com1_rx_eflg){				// COM1  ˻
	TST  R2
	BRNE PC+2
	RJMP _0x86
;     719 			if(com1_rx_data == '0') exit_flg = 1;	//  ޴ 
	RCALL SUBOPT_0x1B
	BRNE _0x87
	LDI  R30,LOW(1)
	LDI  R31,HIGH(1)
	RCALL SUBOPT_0x2D
;     720 			else if(com1_rx_data == '1'){
	RJMP _0x88
_0x87:
	RCALL SUBOPT_0xF
	BREQ PC+2
	RJMP _0x89
;     721 				i = j = cnt = 0;
	RCALL SUBOPT_0x2E
;     722 				printf("\r\nREAD(###(Add),***(Count)) > ");
	__POINTW1FN _0,1937
	RCALL SUBOPT_0x14
;     723 				urx_string(buff);
	RCALL SUBOPT_0x2F
;     724 				ch = buff[i++];			//  ˻ ڷ 
;     725 				while(ch != 0x0){
_0x8A:
	CPI  R17,0
	BREQ _0x8C
;     726 					if((ch == ':') || (ch == ',') || (ch == ' ')){
	CPI  R17,58
	BREQ _0x8E
	CPI  R17,44
	BREQ _0x8E
	CPI  R17,32
	BRNE _0x8D
_0x8E:
;     727 						j = 0;
	RCALL SUBOPT_0x30
;     728 						cnt++;
;     729 					}
;     730 					else{
	RJMP _0x90
_0x8D:
;     731 						if(cnt == 0){
	LDD  R30,Y+12
	LDD  R31,Y+12+1
	SBIW R30,0
	BRNE _0x91
;     732 							buff1[j++] = ch;
	RCALL SUBOPT_0x31
	RCALL SUBOPT_0x32
	RCALL SUBOPT_0x33
;     733 							buff1[j] = 0x0;
	RCALL SUBOPT_0x32
	RJMP _0x134
;     734 						}
;     735 						else if(cnt == 1){
_0x91:
	RCALL SUBOPT_0x34
	BRNE _0x93
;     736 				    			buff2[j++] = ch;
	RCALL SUBOPT_0x31
	RCALL SUBOPT_0x35
	RCALL SUBOPT_0x33
;     737 				    			buff2[j] = 0x0;
	RCALL SUBOPT_0x35
_0x134:
	ADD  R26,R20
	ADC  R27,R21
	RCALL SUBOPT_0x36
;     738 						}
;     739 			    		}
_0x93:
_0x90:
;     740 				    	ch = buff[i++];
	RCALL SUBOPT_0x37
;     741 				}
	RJMP _0x8A
_0x8C:
;     742 				if(cnt == 1){			// ˻ 
	RCALL SUBOPT_0x34
	BRNE _0x94
;     743 					saddr = (unsigned int)atoh(buff1);//  ּ ȯ(HEX)
	RCALL SUBOPT_0x38
;     744 					ecnt = (unsigned int)atoh(buff2);// ī ȯ(HEX)
;     745 					printf("%04X > ",saddr);// ּ ǥ
	__POINTW1FN _0,1968
	RCALL SUBOPT_0x25
	RCALL SUBOPT_0x2C
	RCALL SUBOPT_0x39
;     746 					cnt = 0;
	LDI  R30,0
	STD  Y+12,R30
	STD  Y+12+1,R30
;     747 			   		for(i = 0; i <= ecnt; i++,saddr++){//  ǥ
	__GETWRN 18,19,0
_0x96:
	RCALL SUBOPT_0x3A
	CP   R30,R18
	CPC  R31,R19
	BRLO _0x97
;     748 						uch = EEPROM_read(saddr);//  
	RCALL SUBOPT_0x3B
	RCALL SUBOPT_0x25
	RCALL _EEPROM_read
	MOV  R16,R30
;     749 						printf("%02X ",uch);// Ÿ ǥ
	__POINTW1FN _0,1976
	RCALL SUBOPT_0x25
	MOV  R30,R16
	RCALL SUBOPT_0x26
	LDI  R24,4
	RCALL _printf
	ADIW R28,6
;     750 						cnt++;
	LDD  R30,Y+12
	LDD  R31,Y+12+1
	ADIW R30,1
	STD  Y+12,R30
	STD  Y+12+1,R31
;     751 						if(cnt == 16){// 1 ǥ
	LDD  R26,Y+12
	LDD  R27,Y+12+1
	SBIW R26,16
	BRNE _0x98
;     752 							cnt = 0;
	LDI  R30,0
	STD  Y+12,R30
	STD  Y+12+1,R30
;     753 							if(i+1 <= ecnt) printf("\r\n%03X > ",saddr+1);// ּ ǥ
	MOVW R26,R18
	ADIW R26,1
	RCALL SUBOPT_0x3A
	CP   R30,R26
	CPC  R31,R27
	BRLO _0x99
	__POINTW1FN _0,1982
	RCALL SUBOPT_0x25
	RCALL SUBOPT_0x2C
	ADIW R30,1
	RCALL SUBOPT_0x39
;     754 						}
_0x99:
;     755 				    	}
_0x98:
	RCALL SUBOPT_0x3C
	RJMP _0x96
_0x97:
;     756 					printf("\r\nRead OK\r\n");
	__POINTW1FN _0,1992
	RCALL SUBOPT_0x14
;     757 				}
;     758 			}
_0x94:
;     759 			else if(com1_rx_data == '2'){
	RJMP _0x9A
_0x89:
	RCALL SUBOPT_0x10
	BREQ PC+2
	RJMP _0x9B
;     760 				i = j = cnt = 0;
	RCALL SUBOPT_0x2E
;     761 				printf("\r\nWRITE(###(Addr),***(Count),**(Data)) > ");
	__POINTW1FN _0,2004
	RCALL SUBOPT_0x14
;     762 				urx_string(buff);
	RCALL SUBOPT_0x2F
;     763 				ch = buff[i++];			//  ˻ ڷ 
;     764 				while(ch != 0x0){
_0x9C:
	CPI  R17,0
	BREQ _0x9E
;     765 					if((ch == ':') || (ch == ',') || (ch == ' ')){
	CPI  R17,58
	BREQ _0xA0
	CPI  R17,44
	BREQ _0xA0
	CPI  R17,32
	BRNE _0x9F
_0xA0:
;     766 						j = 0;
	RCALL SUBOPT_0x30
;     767 						cnt++;
;     768 					}
;     769 					else{
	RJMP _0xA2
_0x9F:
;     770 						if(cnt == 0){
	LDD  R30,Y+12
	LDD  R31,Y+12+1
	SBIW R30,0
	BRNE _0xA3
;     771 							buff1[j++] = ch;
	RCALL SUBOPT_0x31
	RCALL SUBOPT_0x32
	RCALL SUBOPT_0x33
;     772 							buff1[j] = 0x0;
	RCALL SUBOPT_0x32
	RJMP _0x135
;     773 						}
;     774 						else if(cnt == 1){
_0xA3:
	RCALL SUBOPT_0x34
	BRNE _0xA5
;     775 							buff2[j++] = ch;
	RCALL SUBOPT_0x31
	RCALL SUBOPT_0x35
	RCALL SUBOPT_0x33
;     776 							buff2[j] = 0x0;
	RCALL SUBOPT_0x35
	RJMP _0x135
;     777 						}
;     778 						else if(cnt == 2){
_0xA5:
	LDD  R26,Y+12
	LDD  R27,Y+12+1
	SBIW R26,2
	BRNE _0xA7
;     779 							buff3[j++] = ch;
	RCALL SUBOPT_0x31
	MOVW R26,R28
	ADIW R26,14
	RCALL SUBOPT_0x33
;     780 							buff3[j] = 0x0;
	MOVW R26,R28
	ADIW R26,14
_0x135:
	ADD  R26,R20
	ADC  R27,R21
	RCALL SUBOPT_0x36
;     781 						}
;     782 					}
_0xA7:
_0xA2:
;     783 					ch = buff[i++];
	RCALL SUBOPT_0x37
;     784 				}
	RJMP _0x9C
_0x9E:
;     785 				if(cnt == 2){			// ˻ 
	LDD  R26,Y+12
	LDD  R27,Y+12+1
	SBIW R26,2
	BRNE _0xA8
;     786 					saddr = (unsigned int)atoh(buff1);//  ּ ȯ(HEX)
	RCALL SUBOPT_0x38
;     787 					ecnt = (unsigned int)atoh(buff2);// ī ּ ȯ(HEX)
;     788 					uch = (unsigned char)atoh(buff3);//  ȯ(HEX)
	MOVW R30,R28
	ADIW R30,14
	RCALL SUBOPT_0x25
	RCALL _atoh
	MOV  R16,R30
;     789 					for(i = 0; i <= ecnt; i++,saddr++) EEPROM_write(saddr,uch);//  
	__GETWRN 18,19,0
_0xAA:
	RCALL SUBOPT_0x3A
	CP   R30,R18
	CPC  R31,R19
	BRLO _0xAB
	RCALL SUBOPT_0x3B
	RCALL SUBOPT_0x25
	ST   -Y,R16
	RCALL _EEPROM_write
;     790 					printf("SRAM Data Write OK\r\n");
	RCALL SUBOPT_0x3C
	RJMP _0xAA
_0xAB:
	__POINTW1FN _0,2046
	RCALL SUBOPT_0x14
;     791 				}
;     792 			}
_0xA8:
;     793 			else putchar(com1_rx_data);		// ݼ
	RJMP _0xAC
_0x9B:
	RCALL SUBOPT_0x12
;     794 			com1_rx_eflg = 0;
_0xAC:
_0x9A:
_0x88:
	CLR  R2
;     795 		}
;     796 	}
_0x86:
	RJMP _0x83
_0x85:
;     797 	main_menu_disp();					//  ޴ ǥ
	RCALL _main_menu_disp
;     798 }
	RCALL __LOADLOCR6
	ADIW R28,63
	ADIW R28,63
	ADIW R28,63
	ADIW R28,15
	RET
;     799 
;     800 // ============================== EEPROM DATA READ ============================
;     801 // [μ] int addr
;     802 // Item1:  ּ(0 - 511)
;     803 // []  (00 - ff)
;     804 // ----------------------------------------------------------------------------
;     805 unsigned char EEPROM_read(int addr)
;     806 {
_EEPROM_read:
;     807 unsigned char ch;
;     808 
;     809 	while(EECR & 0x02);					//   Ϸñ 
	ST   -Y,R17
;	addr -> Y+1
;	ch -> R17
_0xAD:
	SBIC 0x1F,1
	RJMP _0xAD
;     810 	EEAR = addr;
	RCALL SUBOPT_0x3D
;     811 	EECR |= 0x01;
	SBI  0x1F,0
;     812 	ch = EEDR;
	IN   R17,32
;     813 	return(ch);
	MOV  R30,R17
	LDD  R17,Y+0
	RJMP _0x131
;     814 }
;     815 
;     816 // ============================== EEPROM DATA  ============================
;     817 // [μ] int addr,unsigned char data
;     818 // Item1:  ּ(0 - 511)
;     819 // Item2:  (00 - ff)
;     820 // ----------------------------------------------------------------------------
;     821 void EEPROM_write(int addr,unsigned char data)
;     822 {
_EEPROM_write:
;     823 	while(EECR & 0x02);					//   Ϸñ 
;	addr -> Y+1
;	data -> Y+0
_0xB0:
	SBIC 0x1F,1
	RJMP _0xB0
;     824 	EEAR = addr;
	RCALL SUBOPT_0x3D
;     825 	EEDR = data;
	LD   R30,Y
	OUT  0x20,R30
;     826 	EECR |= 0x04;
	SBI  0x1F,2
;     827 	EECR |= 0x02;
	SBI  0x1F,1
;     828 }
_0x131:
	ADIW R28,3
	RET
;     829 
;     830 // ============================ κ ڿ  ====================
;     831 // [μ] char buff[]
;     832 // Item1   Ÿ  (ִ 30)
;     833 // ----------------------------------------------------------------------------
;     834 void urx_string(char buff[])
;     835 {
_urx_string:
;     836 char ch;
;     837 int exit_flg = 0,scnt = 0;
;     838 
;     839 	com1_rx_eflg = 0;
	RCALL __SAVELOCR6
;	*buff -> Y+6
;	ch -> R17
;	exit_flg -> R18,R19
;	scnt -> R20,R21
	LDI  R18,0
	LDI  R19,0
	LDI  R20,0
	LDI  R21,0
	CLR  R2
;     840 	buff[0] = 0x0;						//  ũ
	RCALL SUBOPT_0x3E
	RCALL SUBOPT_0x36
;     841 	while(exit_flg == 0){
_0xB3:
	MOV  R0,R18
	OR   R0,R19
	BRNE _0xB5
;     842 	    while(com1_rx_eflg == 0); com1_rx_eflg = 0;		// 1 
_0xB6:
	TST  R2
	BREQ _0xB6
	CLR  R2
;     843 	    ch = com1_rx_data;					//  Ÿ ε
	MOV  R17,R3
;     844 	    ch = toupper(ch);					//  ȯ
	RCALL SUBOPT_0x3F
;     845 	    if(ch == 0x08){					// BSŰ м
	CPI  R17,8
	BRNE _0xB9
;     846 			if(scnt == 0) putchar(0x07);		//  溸 ۽
	MOV  R0,R20
	OR   R0,R21
	BRNE _0xBA
	LDI  R30,LOW(7)
	RCALL SUBOPT_0x40
;     847 			else{					// 1ڸ 
	RJMP _0xBB
_0xBA:
;     848 			    putchar(0x08);
	LDI  R30,LOW(8)
	RCALL SUBOPT_0x40
;     849 			    putchar(' ');
	LDI  R30,LOW(32)
	RCALL SUBOPT_0x40
;     850 			    putchar(0x08);
	LDI  R30,LOW(8)
	RCALL SUBOPT_0x40
;     851 			    scnt--;
	__SUBWRN 20,21,1
;     852 			}
_0xBB:
;     853 	    }
;     854 	    else if(ch == 0x0d){
	RJMP _0xBC
_0xB9:
	CPI  R17,13
	BRNE _0xBD
;     855 			exit_flg = 1;				// Ż  ON
	__GETWRN 18,19,1
;     856 			buff[scnt] = 0x0;
	MOVW R30,R20
	RCALL SUBOPT_0x3E
	ADD  R26,R30
	ADC  R27,R31
	RCALL SUBOPT_0x36
;     857 			printf("\r\n");
	RCALL SUBOPT_0x13
;     858 	    }
;     859 	    else{
	RJMP _0xBE
_0xBD:
;     860 			buff[scnt++] = ch;			// ڷ 
	RCALL SUBOPT_0x31
	RCALL SUBOPT_0x3E
	RCALL SUBOPT_0x33
;     861 			putchar(ch);
	ST   -Y,R17
	RCALL _putchar
;     862 			if(scnt >= 30){ 			//   ʰ 
	__CPWRN 20,21,30
	BRLT _0xBF
;     863 			    scnt = 29;
	__GETWRN 20,21,29
;     864 			    putchar(0x08);
	LDI  R30,LOW(8)
	RCALL SUBOPT_0x40
;     865 			    putchar(0x07);
	LDI  R30,LOW(7)
	RCALL SUBOPT_0x40
;     866 			}
;     867 	    }
_0xBF:
_0xBE:
_0xBC:
;     868 	}
	RJMP _0xB3
_0xB5:
;     869 }
	RCALL __LOADLOCR6
	ADIW R28,8
	RET
;     870 
;     871 // ========================== ASCII͸ HEXͷ ȯ ==================
;     872 // [μ] unsigned char buff[]
;     873 // Item1  ȯ 
;     874 // [] 0 - 7fffffffh
;     875 // ----------------------------------------------------------------------------
;     876 long atoh(char buff[])
;     877 {
_atoh:
;     878 char ch;
;     879 int i = 0;
;     880 long data = 0;
;     881 
;     882 	ch = buff[i++]; 					//  ε
	SBIW R28,4
	LDI  R24,4
	LDI  R26,LOW(0)
	LDI  R27,HIGH(0)
	LDI  R30,LOW(_0xC0*2)
	LDI  R31,HIGH(_0xC0*2)
	RCALL __INITLOCB
	RCALL SUBOPT_0x15
;	*buff -> Y+8
;	ch -> R17
;	i -> R18,R19
;	data -> Y+4
	RCALL SUBOPT_0x41
;     883 	ch = toupper(ch);					// 빮 ȯ
;     884 	while(ch != 0){
_0xC1:
	CPI  R17,0
	BREQ _0xC3
;     885 		ch = ch - '0';              			// 0 - 9 ȯ
	SUBI R17,LOW(48)
;     886 		if(ch > 9) ch = ch - 7;				// A - F ȯ
	CPI  R17,10
	BRLO _0xC4
	SUBI R17,LOW(7)
;     887 		if(ch < 0 || ch > 0x0f) ch = 0;			//  ˻
_0xC4:
	CPI  R17,0
	BRLO _0xC6
	CPI  R17,16
	BRLO _0xC5
_0xC6:
	LDI  R17,LOW(0)
;     888 		else ch = ch & 0x0f;
	RJMP _0xC8
_0xC5:
	ANDI R17,LOW(15)
;     889 		data = data << 4;				// ȯ  
_0xC8:
	RCALL SUBOPT_0x42
	LDI  R30,LOW(4)
	RCALL __LSLD12
	RCALL SUBOPT_0x43
;     890 		data |= ch;
	MOV  R30,R17
	RCALL SUBOPT_0x42
	CLR  R31
	CLR  R22
	CLR  R23
	RCALL __ORD12
	RCALL SUBOPT_0x43
;     891 		ch = buff[i++];					//  ε
	RCALL SUBOPT_0x41
;     892 		ch = toupper(ch);				// 빮 ȯ
;     893 	}
	RJMP _0xC1
_0xC3:
;     894 	return(data);
	__GETD1S 4
	RCALL __LOADLOCR4
	ADIW R28,10
	RET
;     895 }

_putchar:
_0xCC:
	LDS  R30,192
	ANDI R30,LOW(0x20)
	BREQ _0xCC
	LD   R30,Y
	STS  198,R30
_0x130:
	ADIW R28,1
	RET
__put_G2:
	RCALL __SAVELOCR2
	LDD  R26,Y+4
	LDD  R27,Y+4+1
	RCALL __GETW1P
	SBIW R30,0
	BREQ _0xCF
	LDD  R26,Y+2
	LDD  R27,Y+2+1
	RCALL __GETW1P
	MOVW R16,R30
	SBIW R30,0
	BREQ _0xD1
	__CPWRN 16,17,2
	BRLO _0xD2
	RCALL SUBOPT_0x1C
	SBIW R30,1
	MOVW R16,R30
	LDD  R26,Y+2
	LDD  R27,Y+2+1
	ST   X+,R30
	ST   X,R31
_0xD1:
	LDD  R26,Y+4
	LDD  R27,Y+4+1
	LD   R30,X+
	LD   R31,X+
	ADIW R30,1
	ST   -X,R31
	ST   -X,R30
	SBIW R30,1
	LDD  R26,Y+6
	STD  Z+0,R26
_0xD2:
	RJMP _0xD3
_0xCF:
	LDD  R30,Y+6
	RCALL SUBOPT_0x40
_0xD3:
	RCALL __LOADLOCR2
	ADIW R28,7
	RET
__print_G2:
	SBIW R28,6
	RCALL __SAVELOCR6
	LDI  R17,0
_0xD4:
	LDD  R30,Y+18
	LDD  R31,Y+18+1
	ADIW R30,1
	STD  Y+18,R30
	STD  Y+18+1,R31
	SBIW R30,1
	LPM  R30,Z
	MOV  R18,R30
	CPI  R30,0
	BRNE PC+2
	RJMP _0xD6
	MOV  R30,R17
	CPI  R30,0
	BRNE _0xDA
	CPI  R18,37
	BRNE _0xDB
	LDI  R17,LOW(1)
	RJMP _0xDC
_0xDB:
	RCALL SUBOPT_0x44
_0xDC:
	RJMP _0xD9
_0xDA:
	CPI  R30,LOW(0x1)
	BRNE _0xDD
	CPI  R18,37
	BRNE _0xDE
	RCALL SUBOPT_0x44
	RJMP _0x136
_0xDE:
	LDI  R17,LOW(2)
	LDI  R20,LOW(0)
	LDI  R16,LOW(0)
	CPI  R18,45
	BRNE _0xDF
	LDI  R16,LOW(1)
	RJMP _0xD9
_0xDF:
	CPI  R18,43
	BRNE _0xE0
	LDI  R20,LOW(43)
	RJMP _0xD9
_0xE0:
	CPI  R18,32
	BRNE _0xE1
	LDI  R20,LOW(32)
	RJMP _0xD9
_0xE1:
	RJMP _0xE2
_0xDD:
	CPI  R30,LOW(0x2)
	BRNE _0xE3
_0xE2:
	LDI  R21,LOW(0)
	LDI  R17,LOW(3)
	CPI  R18,48
	BRNE _0xE4
	ORI  R16,LOW(128)
	RJMP _0xD9
_0xE4:
	RJMP _0xE5
_0xE3:
	CPI  R30,LOW(0x3)
	BREQ PC+2
	RJMP _0xD9
_0xE5:
	CPI  R18,48
	BRLO _0xE8
	CPI  R18,58
	BRLO _0xE9
_0xE8:
	RJMP _0xE7
_0xE9:
	MOV  R26,R21
	LDI  R30,LOW(10)
	MUL  R30,R26
	MOVW R30,R0
	MOV  R21,R30
	MOV  R30,R18
	SUBI R30,LOW(48)
	ADD  R21,R30
	RJMP _0xD9
_0xE7:
	MOV  R30,R18
	CPI  R30,LOW(0x63)
	BRNE _0xED
	RCALL SUBOPT_0x45
	LD   R30,X
	RCALL SUBOPT_0x46
	RJMP _0xEE
_0xED:
	CPI  R30,LOW(0x73)
	BRNE _0xF0
	RCALL SUBOPT_0x45
	RCALL SUBOPT_0x47
	RCALL _strlen
	MOV  R17,R30
	RJMP _0xF1
_0xF0:
	CPI  R30,LOW(0x70)
	BRNE _0xF3
	RCALL SUBOPT_0x45
	RCALL SUBOPT_0x47
	RCALL _strlenf
	MOV  R17,R30
	ORI  R16,LOW(8)
_0xF1:
	ORI  R16,LOW(2)
	ANDI R16,LOW(127)
	LDI  R19,LOW(0)
	RJMP _0xF4
_0xF3:
	CPI  R30,LOW(0x64)
	BREQ _0xF7
	CPI  R30,LOW(0x69)
	BRNE _0xF8
_0xF7:
	ORI  R16,LOW(4)
	RJMP _0xF9
_0xF8:
	CPI  R30,LOW(0x75)
	BRNE _0xFA
_0xF9:
	LDI  R30,LOW(_tbl10_G2*2)
	LDI  R31,HIGH(_tbl10_G2*2)
	RCALL SUBOPT_0x48
	LDI  R17,LOW(5)
	RJMP _0xFB
_0xFA:
	CPI  R30,LOW(0x58)
	BRNE _0xFD
	ORI  R16,LOW(8)
	RJMP _0xFE
_0xFD:
	CPI  R30,LOW(0x78)
	BREQ PC+2
	RJMP _0x12F
_0xFE:
	LDI  R30,LOW(_tbl16_G2*2)
	LDI  R31,HIGH(_tbl16_G2*2)
	RCALL SUBOPT_0x48
	LDI  R17,LOW(4)
_0xFB:
	SBRS R16,2
	RJMP _0x100
	RCALL SUBOPT_0x45
	RCALL __GETW1P
	RCALL SUBOPT_0x2D
	LDD  R26,Y+10
	LDD  R27,Y+10+1
	SBIW R26,0
	BRGE _0x101
	RCALL SUBOPT_0x2C
	RCALL __ANEGW1
	RCALL SUBOPT_0x2D
	LDI  R20,LOW(45)
_0x101:
	CPI  R20,0
	BREQ _0x102
	SUBI R17,-LOW(1)
	RJMP _0x103
_0x102:
	ANDI R16,LOW(251)
_0x103:
	RJMP _0x104
_0x100:
	RCALL SUBOPT_0x45
	RCALL __GETW1P
	RCALL SUBOPT_0x2D
_0x104:
_0xF4:
	SBRC R16,0
	RJMP _0x105
_0x106:
	CP   R17,R21
	BRSH _0x108
	SBRS R16,7
	RJMP _0x109
	SBRS R16,2
	RJMP _0x10A
	ANDI R16,LOW(251)
	MOV  R18,R20
	SUBI R17,LOW(1)
	RJMP _0x10B
_0x10A:
	LDI  R18,LOW(48)
_0x10B:
	RJMP _0x10C
_0x109:
	LDI  R18,LOW(32)
_0x10C:
	RCALL SUBOPT_0x44
	SUBI R21,LOW(1)
	RJMP _0x106
_0x108:
_0x105:
	MOV  R19,R17
	SBRS R16,1
	RJMP _0x10D
_0x10E:
	CPI  R19,0
	BREQ _0x110
	SBRS R16,3
	RJMP _0x111
	RCALL SUBOPT_0x3A
	ADIW R30,1
	RCALL SUBOPT_0x48
	SBIW R30,1
	LPM  R30,Z
	RJMP _0x137
_0x111:
	RCALL SUBOPT_0x3E
	LD   R30,X+
	STD  Y+6,R26
	STD  Y+6+1,R27
_0x137:
	ST   -Y,R30
	RCALL SUBOPT_0x49
	CPI  R21,0
	BREQ _0x113
	SUBI R21,LOW(1)
_0x113:
	SUBI R19,LOW(1)
	RJMP _0x10E
_0x110:
	RJMP _0x114
_0x10D:
_0x116:
	LDI  R18,LOW(48)
	RCALL SUBOPT_0x3A
	ADIW R30,2
	RCALL SUBOPT_0x48
	SBIW R30,2
	RCALL __GETW1PF
	STD  Y+8,R30
	STD  Y+8+1,R31
_0x118:
	RCALL SUBOPT_0x3B
	LDD  R26,Y+10
	LDD  R27,Y+10+1
	CP   R26,R30
	CPC  R27,R31
	BRLO _0x11A
	SUBI R18,-LOW(1)
	LDD  R26,Y+8
	LDD  R27,Y+8+1
	RCALL SUBOPT_0x2C
	SUB  R30,R26
	SBC  R31,R27
	RCALL SUBOPT_0x2D
	RJMP _0x118
_0x11A:
	CPI  R18,58
	BRLO _0x11B
	SBRS R16,3
	RJMP _0x11C
	SUBI R18,-LOW(7)
	RJMP _0x11D
_0x11C:
	SUBI R18,-LOW(39)
_0x11D:
_0x11B:
	SBRC R16,4
	RJMP _0x11F
	CPI  R18,49
	BRSH _0x121
	LDD  R26,Y+8
	LDD  R27,Y+8+1
	SBIW R26,1
	BRNE _0x120
_0x121:
	RJMP _0x138
_0x120:
	CP   R21,R19
	BRLO _0x125
	SBRS R16,0
	RJMP _0x126
_0x125:
	RJMP _0x124
_0x126:
	LDI  R18,LOW(32)
	SBRS R16,7
	RJMP _0x127
	LDI  R18,LOW(48)
_0x138:
	ORI  R16,LOW(16)
	SBRS R16,2
	RJMP _0x128
	ANDI R16,LOW(251)
	ST   -Y,R20
	RCALL SUBOPT_0x49
	CPI  R21,0
	BREQ _0x129
	SUBI R21,LOW(1)
_0x129:
_0x128:
_0x127:
_0x11F:
	RCALL SUBOPT_0x44
	CPI  R21,0
	BREQ _0x12A
	SUBI R21,LOW(1)
_0x12A:
_0x124:
	SUBI R19,LOW(1)
	LDD  R26,Y+8
	LDD  R27,Y+8+1
	SBIW R26,2
	BRLO _0x117
	RJMP _0x116
_0x117:
_0x114:
	SBRS R16,0
	RJMP _0x12B
_0x12C:
	CPI  R21,0
	BREQ _0x12E
	SUBI R21,LOW(1)
	LDI  R30,LOW(32)
	RCALL SUBOPT_0x46
	RJMP _0x12C
_0x12E:
_0x12B:
_0x12F:
_0xEE:
_0x136:
	LDI  R17,LOW(0)
_0xD9:
	RJMP _0xD4
_0xD6:
	RCALL __LOADLOCR6
	ADIW R28,20
	RET
_printf:
	PUSH R15
	MOV  R15,R24
	SBIW R28,2
	RCALL __SAVELOCR2
	MOVW R26,R28
	RCALL __ADDW2R15
	MOVW R16,R26
	LDI  R30,0
	STD  Y+2,R30
	STD  Y+2+1,R30
	MOVW R26,R28
	ADIW R26,4
	RCALL __ADDW2R15
	RCALL __GETW1P
	RCALL SUBOPT_0x25
	ST   -Y,R17
	ST   -Y,R16
	MOVW R30,R28
	ADIW R30,6
	RCALL SUBOPT_0x25
	RCALL SUBOPT_0x21
	RCALL SUBOPT_0x25
	RCALL __print_G2
	RCALL __LOADLOCR2
	ADIW R28,4
	POP  R15
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:9 WORDS
SUBOPT_0x0:
	LDI  R30,LOW(0)
	OUT  0x5,R30
	OUT  0x4,R30
	OUT  0x8,R30
	OUT  0x7,R30
	OUT  0xB,R30
	OUT  0xA,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 5 TIMES, CODE SIZE REDUCTION:2 WORDS
SUBOPT_0x1:
	LDI  R30,LOW(0)
	OUT  0x24,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:4 WORDS
SUBOPT_0x2:
	LDI  R30,LOW(0)
	OUT  0x25,R30
	OUT  0x26,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:7 WORDS
SUBOPT_0x3:
	LDI  R30,LOW(0)
	OUT  0x27,R30
	OUT  0x28,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:2 WORDS
SUBOPT_0x4:
	LDI  R30,LOW(0)
	STS  128,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:24 WORDS
SUBOPT_0x5:
	LDI  R30,LOW(0)
	STS  129,R30
	STS  133,R30
	STS  132,R30
	STS  135,R30
	STS  134,R30
	STS  137,R30
	STS  136,R30
	STS  139,R30
	STS  138,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:8 WORDS
SUBOPT_0x6:
	LDI  R30,LOW(0)
	STS  182,R30
	STS  176,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:9 WORDS
SUBOPT_0x7:
	LDI  R30,LOW(0)
	STS  177,R30
	STS  178,R30
	STS  179,R30
	STS  180,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:7 WORDS
SUBOPT_0x8:
	LDI  R30,LOW(0)
	STS  105,R30
	OUT  0x1D,R30
	OUT  0x1C,R30
	STS  104,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 5 TIMES, CODE SIZE REDUCTION:2 WORDS
SUBOPT_0x9:
	STS  110,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:4 WORDS
SUBOPT_0xA:
	ST   -Y,R30
	ST   -Y,R31
	IN   R30,SREG
	ST   -Y,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:4 WORDS
SUBOPT_0xB:
	LD   R30,Y+
	OUT  SREG,R30
	LD   R31,Y+
	LD   R30,Y+
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0xC:
	LDI  R30,LOW(243)
	STS  133,R30
	LDI  R30,LOW(207)
	STS  132,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0xD:
	ST   -Y,R30
	ST   -Y,R31
	LDI  R30,LOW(1)
	LDI  R31,HIGH(1)
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0xE:
	LDS  R30,120
	LDS  R31,120+1
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0xF:
	LDI  R30,LOW(49)
	CP   R30,R3
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x10:
	LDI  R30,LOW(50)
	CP   R30,R3
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 5 TIMES, CODE SIZE REDUCTION:2 WORDS
SUBOPT_0x11:
	LDI  R30,LOW(56)
	CP   R30,R3
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 9 TIMES, CODE SIZE REDUCTION:6 WORDS
SUBOPT_0x12:
	ST   -Y,R3
	RJMP _putchar

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:4 WORDS
SUBOPT_0x13:
	__POINTW1FN _0,0
	ST   -Y,R31
	ST   -Y,R30
	LDI  R24,0
	RCALL _printf
	ADIW R28,2
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 70 TIMES, CODE SIZE REDUCTION:274 WORDS
SUBOPT_0x14:
	ST   -Y,R31
	ST   -Y,R30
	LDI  R24,0
	RCALL _printf
	ADIW R28,2
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:2 WORDS
SUBOPT_0x15:
	RCALL __SAVELOCR4
	LDI  R18,0
	LDI  R19,0
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 5 TIMES, CODE SIZE REDUCTION:6 WORDS
SUBOPT_0x16:
	__POINTW1FN _0,455
	RJMP SUBOPT_0x14

;OPTIMIZER ADDED SUBROUTINE, CALLED 6 TIMES, CODE SIZE REDUCTION:8 WORDS
SUBOPT_0x17:
	__POINTW1FN _0,497
	RJMP SUBOPT_0x14

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:2 WORDS
SUBOPT_0x18:
	LDI  R30,LOW(5)
	OUT  0x25,R30
	LDI  R30,LOW(60)
	OUT  0x26,R30
	RJMP SUBOPT_0x3

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x19:
	LDS  R30,110
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x1A:
	ORI  R30,1
	RCALL SUBOPT_0x9
	CLR  R4
	CLR  R5
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 8 TIMES, CODE SIZE REDUCTION:5 WORDS
SUBOPT_0x1B:
	LDI  R30,LOW(48)
	CP   R30,R3
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 5 TIMES, CODE SIZE REDUCTION:2 WORDS
SUBOPT_0x1C:
	MOVW R30,R16
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:2 WORDS
SUBOPT_0x1D:
	LDI  R26,LOW(1)
	LDI  R27,HIGH(1)
	RCALL __LSLW12
	COM  R30
	COM  R31
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 6 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0x1E:
	MOV  R0,R16
	OR   R0,R17
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 5 TIMES, CODE SIZE REDUCTION:6 WORDS
SUBOPT_0x1F:
	RCALL __SAVELOCR2
	LDI  R16,0
	LDI  R17,0
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 5 TIMES, CODE SIZE REDUCTION:2 WORDS
SUBOPT_0x20:
	__GETWRN 16,17,1
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x21:
	LDI  R30,LOW(0)
	LDI  R31,HIGH(0)
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:13 WORDS
SUBOPT_0x22:
	LDI  R30,LOW(0)
	STS  126,R30
	STS  124,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 7 TIMES, CODE SIZE REDUCTION:4 WORDS
SUBOPT_0x23:
	STS  122,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 8 TIMES, CODE SIZE REDUCTION:19 WORDS
SUBOPT_0x24:
	ST   -Y,R30
	RCALL _ad_read
	MOVW R16,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 35 TIMES, CODE SIZE REDUCTION:32 WORDS
SUBOPT_0x25:
	ST   -Y,R31
	ST   -Y,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x26:
	CLR  R31
	CLR  R22
	CLR  R23
	RCALL __PUTPARD1
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0x27:
	CLR  R22
	CLR  R23
	RCALL __PUTPARD1
	LDI  R24,8
	RCALL _printf
	ADIW R28,10
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:5 WORDS
SUBOPT_0x28:
	LDI  R30,LOW(0)
	RCALL SUBOPT_0x23
	LDS  R30,123
	ANDI R30,LOW(0xF8)
	STS  123,R30
	RJMP _main_menu_disp

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:4 WORDS
SUBOPT_0x29:
	LD   R30,Y
	STS  124,R30
	LDS  R30,122
	ORI  R30,0x40
	RJMP SUBOPT_0x23

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:2 WORDS
SUBOPT_0x2A:
	LDI  R30,0
	STS  _adc_int_flg,R30
	STS  _adc_int_flg+1,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 8 TIMES, CODE SIZE REDUCTION:5 WORDS
SUBOPT_0x2B:
	ST   -Y,R30
	RJMP _ad_start

;OPTIMIZER ADDED SUBROUTINE, CALLED 5 TIMES, CODE SIZE REDUCTION:2 WORDS
SUBOPT_0x2C:
	LDD  R30,Y+10
	LDD  R31,Y+10+1
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 5 TIMES, CODE SIZE REDUCTION:2 WORDS
SUBOPT_0x2D:
	STD  Y+10,R30
	STD  Y+10+1,R31
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:4 WORDS
SUBOPT_0x2E:
	RCALL SUBOPT_0x21
	STD  Y+12,R30
	STD  Y+12+1,R31
	MOVW R20,R30
	MOVW R18,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:12 WORDS
SUBOPT_0x2F:
	MOVW R30,R28
	SUBI R30,LOW(-(104))
	SBCI R31,HIGH(-(104))
	RCALL SUBOPT_0x25
	RCALL _urx_string
	MOVW R30,R18
	__ADDWRN 18,19,1
	MOVW R26,R28
	SUBI R26,LOW(-(104))
	SBCI R27,HIGH(-(104))
	ADD  R26,R30
	ADC  R27,R31
	LD   R17,X
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:4 WORDS
SUBOPT_0x30:
	__GETWRN 20,21,0
	LDD  R30,Y+12
	LDD  R31,Y+12+1
	ADIW R30,1
	STD  Y+12,R30
	STD  Y+12+1,R31
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 6 TIMES, CODE SIZE REDUCTION:13 WORDS
SUBOPT_0x31:
	MOVW R30,R20
	__ADDWRN 20,21,1
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:4 WORDS
SUBOPT_0x32:
	MOVW R26,R28
	SUBI R26,LOW(-(74))
	SBCI R27,HIGH(-(74))
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 6 TIMES, CODE SIZE REDUCTION:8 WORDS
SUBOPT_0x33:
	ADD  R30,R26
	ADC  R31,R27
	ST   Z,R17
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:2 WORDS
SUBOPT_0x34:
	LDD  R26,Y+12
	LDD  R27,Y+12+1
	SBIW R26,1
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x35:
	MOVW R26,R28
	ADIW R26,44
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x36:
	LDI  R30,LOW(0)
	ST   X,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:7 WORDS
SUBOPT_0x37:
	MOVW R30,R18
	__ADDWRN 18,19,1
	MOVW R26,R28
	SUBI R26,LOW(-(104))
	SBCI R27,HIGH(-(104))
	ADD  R26,R30
	ADC  R27,R31
	LD   R17,X
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:10 WORDS
SUBOPT_0x38:
	MOVW R30,R28
	SUBI R30,LOW(-(74))
	SBCI R31,HIGH(-(74))
	RCALL SUBOPT_0x25
	RCALL _atoh
	STD  Y+8,R30
	STD  Y+8+1,R31
	MOVW R30,R28
	ADIW R30,44
	RCALL SUBOPT_0x25
	RCALL _atoh
	STD  Y+6,R30
	STD  Y+6+1,R31
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0x39:
	CLR  R22
	CLR  R23
	RCALL __PUTPARD1
	LDI  R24,4
	RCALL _printf
	ADIW R28,6
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 7 TIMES, CODE SIZE REDUCTION:4 WORDS
SUBOPT_0x3A:
	LDD  R30,Y+6
	LDD  R31,Y+6+1
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 5 TIMES, CODE SIZE REDUCTION:2 WORDS
SUBOPT_0x3B:
	LDD  R30,Y+8
	LDD  R31,Y+8+1
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0x3C:
	__ADDWRN 18,19,1
	RCALL SUBOPT_0x3B
	ADIW R30,1
	STD  Y+8,R30
	STD  Y+8+1,R31
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x3D:
	LDD  R30,Y+1
	LDD  R31,Y+1+1
	OUT  0x21+1,R31
	OUT  0x21,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x3E:
	LDD  R26,Y+6
	LDD  R27,Y+6+1
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:2 WORDS
SUBOPT_0x3F:
	ST   -Y,R17
	RCALL _toupper
	MOV  R17,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 7 TIMES, CODE SIZE REDUCTION:4 WORDS
SUBOPT_0x40:
	ST   -Y,R30
	RJMP _putchar

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:7 WORDS
SUBOPT_0x41:
	MOVW R30,R18
	__ADDWRN 18,19,1
	LDD  R26,Y+8
	LDD  R27,Y+8+1
	ADD  R26,R30
	ADC  R27,R31
	LD   R17,X
	RJMP SUBOPT_0x3F

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x42:
	__GETD2S 4
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x43:
	__PUTD1S 4
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:19 WORDS
SUBOPT_0x44:
	ST   -Y,R18
	LDD  R30,Y+15
	LDD  R31,Y+15+1
	RCALL SUBOPT_0x25
	MOVW R30,R28
	ADIW R30,15
	RCALL SUBOPT_0x25
	RJMP __put_G2

;OPTIMIZER ADDED SUBROUTINE, CALLED 5 TIMES, CODE SIZE REDUCTION:18 WORDS
SUBOPT_0x45:
	LDD  R26,Y+16
	LDD  R27,Y+16+1
	SBIW R26,4
	STD  Y+16,R26
	STD  Y+16+1,R27
	ADIW R26,4
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:5 WORDS
SUBOPT_0x46:
	ST   -Y,R30
	LDD  R30,Y+15
	LDD  R31,Y+15+1
	RCALL SUBOPT_0x25
	MOVW R30,R28
	ADIW R30,15
	RCALL SUBOPT_0x25
	RJMP __put_G2

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:2 WORDS
SUBOPT_0x47:
	RCALL __GETW1P
	STD  Y+6,R30
	STD  Y+6+1,R31
	RCALL SUBOPT_0x3A
	RJMP SUBOPT_0x25

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x48:
	STD  Y+6,R30
	STD  Y+6+1,R31
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:4 WORDS
SUBOPT_0x49:
	LDD  R30,Y+15
	LDD  R31,Y+15+1
	RCALL SUBOPT_0x25
	MOVW R30,R28
	ADIW R30,15
	RCALL SUBOPT_0x25
	RJMP __put_G2

_strlen:
	ld   r26,y+
	ld   r27,y+
	clr  r30
	clr  r31
__strlen0:
	ld   r22,x+
	tst  r22
	breq __strlen1
	adiw r30,1
	rjmp __strlen0
__strlen1:
	ret

_strlenf:
	clr  r26
	clr  r27
	ld   r30,y+
	ld   r31,y+
__strlenf0:
	lpm  r0,z+
	tst  r0
	breq __strlenf1
	adiw r26,1
	rjmp __strlenf0
__strlenf1:
	movw r30,r26
	ret

_toupper:
	ld   r30,y+
	cpi  r30,'a'
	brlo __toupper0
	cpi  r30,'z'+1
	brcc __toupper0
	subi r30,32
__toupper0:
	ret

__ADDW2R15:
	CLR  R0
	ADD  R26,R15
	ADC  R27,R0
	RET

__ORD12:
	OR   R30,R26
	OR   R31,R27
	OR   R22,R24
	OR   R23,R25
	RET

__ANEGW1:
	COM  R30
	COM  R31
	ADIW R30,1
	RET

__LSLW12:
	TST  R30
	MOV  R0,R30
	MOVW R30,R26
	BREQ __LSLW12R
__LSLW12L:
	LSL  R30
	ROL  R31
	DEC  R0
	BRNE __LSLW12L
__LSLW12R:
	RET

__LSLD12:
	TST  R30
	MOV  R0,R30
	MOVW R30,R26
	MOVW R22,R24
	BREQ __LSLD12R
__LSLD12L:
	LSL  R30
	ROL  R31
	ROL  R22
	ROL  R23
	DEC  R0
	BRNE __LSLD12L
__LSLD12R:
	RET

__CWD1:
	MOV  R22,R31
	ADD  R22,R22
	SBC  R22,R22
	MOV  R23,R22
	RET

__GETW1P:
	LD   R30,X+
	LD   R31,X
	SBIW R26,1
	RET

__GETW1PF:
	LPM  R0,Z+
	LPM  R31,Z
	MOV  R30,R0
	RET

__PUTPARD1:
	ST   -Y,R23
	ST   -Y,R22
	ST   -Y,R31
	ST   -Y,R30
	RET

__SAVELOCR6:
	ST   -Y,R21
__SAVELOCR5:
	ST   -Y,R20
__SAVELOCR4:
	ST   -Y,R19
__SAVELOCR3:
	ST   -Y,R18
__SAVELOCR2:
	ST   -Y,R17
	ST   -Y,R16
	RET

__LOADLOCR6:
	LDD  R21,Y+5
__LOADLOCR5:
	LDD  R20,Y+4
__LOADLOCR4:
	LDD  R19,Y+3
__LOADLOCR3:
	LDD  R18,Y+2
__LOADLOCR2:
	LDD  R17,Y+1
	LD   R16,Y
	RET

__LOADLOCR2P:
	LD   R16,Y+
	LD   R17,Y+
	RET

__INITLOCB:
__INITLOCW:
	ADD R26,R28
	ADC R27,R29
__INITLOC0:
	LPM  R0,Z+
	ST   X+,R0
	DEC  R24
	BRNE __INITLOC0
	RET

;END OF CODE MARKER
__END_OF_CODE:
