// ============================ Atmega88 CPU ׽Ʈ α׷ ===================
//  CPU : ATmega88-20M
//     ¥ : 2008-
//      : Ver1.0
//    : www.cpuplaza.com
// Ϸ : CodeVisionAVR 
//      : serial 19200,N,8,1
// ----------------------------------------------------------------------------
// ⺻ 
// CodeVisionAVR C Compiler
// (C) 1998-2004 Pavel Haiduc, HP InfoTech S.R.L.

// I/O registers definitions for the ATmega88(V)


#pragma used+
sfrb PINB=3;
sfrb DDRB=4;
sfrb PORTB=5;
sfrb PINC=6;
sfrb DDRC=7;
sfrb PORTC=8;
sfrb PIND=9;
sfrb DDRD=0xa;
sfrb PORTD=0xb;
sfrb TIFR0=0x15;
sfrb TIFR1=0x16;
sfrb TIFR2=0x17;
sfrb PCIFR=0x1b;
sfrb EIFR=0x1c;
sfrb EIMSK=0x1d;
sfrb GPIOR0=0x1e;
sfrb EECR=0x1f;
sfrb EEDR=0x20;
sfrb EEARL=0x21;
sfrb EEARH=0x22;
sfrw EEAR=0x21;   // 16 bit access
sfrb GTCCR=0x23;
sfrb TCCR0A=0x24;
sfrb TCCR0B=0x25;
sfrb TCNT0=0x26;
sfrb OCR0A=0x27;
sfrb OCR0B=0x28;
sfrb GPIOR1=0x2a;
sfrb GPIOR2=0x2b;
sfrb SPCR=0x2c;
sfrb SPSR=0x2d;
sfrb SPDR=0x2e;
sfrb ACSR=0x30;
sfrb MONDR=0x31;
sfrb SMCR=0x33;
sfrb MCUSR=0x34;
sfrb MCUCR=0x35;
sfrb SPMCSR=0x37;
sfrb SPL=0x3d;
sfrb SPH=0x3e;
sfrb SREG=0x3f;
#pragma used-


// Interrupt vectors definitions




// CodeVisionAVR C Compiler
// (C) 1998-2006 Pavel Haiduc, HP InfoTech S.R.L.

// Prototypes for standard I/O functions


// CodeVisionAVR C Compiler
// (C) 1998-2002 Pavel Haiduc, HP InfoTech S.R.L.

// Variable length argument list macros



typedef char *va_list;





#pragma used+

char getchar(void);
void putchar(char c);
void puts(char *str);
void putsf(char flash *str);

char *gets(char *str,unsigned int len);

void printf(char flash *fmtstr,...);
void sprintf(char *str, char flash *fmtstr,...);
void snprintf(char *str, unsigned int size, char flash *fmtstr,...);
void vprintf (char flash * fmtstr, va_list argptr);
void vsprintf (char *str, char flash * fmtstr, va_list argptr);
void vsnprintf (char *str, unsigned int size, char flash * fmtstr, va_list argptr);
signed char scanf(char flash *fmtstr,...);
signed char sscanf(char *str, char flash *fmtstr,...);




                                   

            


#pragma used-

#pragma library stdio.lib


/* CodeVisionAVR C Compiler
   Prototypes for standard library functions

   (C) 1998-2003 Pavel Haiduc, HP InfoTech S.R.L.
*/




#pragma used+

int atoi(char *str);
long int atol(char *str);
float atof(char *str);
void itoa(int n,char *str);
void ltoa(long int n,char *str);
void ftoa(float n,unsigned char decimals,char *str);
void ftoe(float n,unsigned char decimals,char *str);
void srand(int seed);
int rand(void);
void *malloc(unsigned int size);
void *calloc(unsigned int num, unsigned int size);
void *realloc(void *ptr, unsigned int size); 
void free(void *ptr);

#pragma used-
#pragma library stdlib.lib


// CodeVisionAVR C Compiler
// (C) 1998-2000 Pavel Haiduc, HP InfoTech S.R.L.

// Prototypes for character type functions


#pragma used+

unsigned char isalnum(char c);
unsigned char isalpha(char c);
unsigned char isascii(char c);
unsigned char iscntrl(char c);
unsigned char isdigit(char c);
unsigned char islower(char c);
unsigned char isprint(char c);
unsigned char ispunct(char c);
unsigned char isspace(char c);
unsigned char isupper(char c);
unsigned char isxdigit(char c);
unsigned char toint(char c);
char tolower(char c);
char toupper(char c);

#pragma used-


/* CodeVisionAVR C Compiler
   (C) 1998-2001 Pavel Haiduc, HP InfoTech S.R.L. */







//  
// =================================== CPUʱȭ ͷƮ ===================
//      : CPU  ϰ ͷƮ  ƾ .
// ----------------------------------------------------------------------------
//   


//  
char com1_rx_data,com1_rx_eflg = 0;				//   ͷƮ  /÷

int timer0_cnt = 0;						// Ÿ̸0 ͷƮ  ī
int timer1_cnt = 0;						// Ÿ̸1 ͷƮ  ī
int timer2_cnt = 0;						// Ÿ̸2 ͷƮ  ī

int exint0_flg = 0;						// EXINT0 ͷƮ  ÷
int exint1_flg = 0;						// EXINT1 ͷƮ  ÷

unsigned int adc_int_data = 0;					// ADC ͷƮ  
int adc_int_ch = 0;						// ADC CH ͷƮ 
int adc_int_flg = 0;						// ADC ͷƮ  ÷

// ===================================== CPUʱȭ ============================
// [μ] void
// ----------------------------------------------------------------------------
void cpu_setup(void)
{
// Crystal Oscillator division factor: 1
#pragma optsize-
	(*(unsigned char *) 0x61)=0x80;
	(*(unsigned char *) 0x61)=0x00;
#pragma optsize+

// PortB 
	PORTB=0x00;						// Ʈ  reg
	DDRB=0x00;						// Ʈ  reg(0Է,1)

// PortC 
	PORTC=0x00;						// Ʈ  reg             
	DDRC=0x00;                                              // Ʈ  reg(0Է,1)

// PortD 
	PORTD=0x00;						// Ʈ  reg             
	DDRD=0x00;                                              // Ʈ  reg(0Է,1)

// Timer/Counter0 
        TCCR0A=0x00;
        TCCR0B=0x00;
        TCNT0=0x00;
        OCR0A=0x00;
        OCR0B=0x00;
	
// Timer/Counter1 
	(*(unsigned char *) 0x80)=0x00;
	(*(unsigned char *) 0x81)=0x00;
	(*(unsigned char *) 0x85)=0x00;
	(*(unsigned char *) 0x84)=0x00;
	(*(unsigned char *) 0x87)=0x00;
	(*(unsigned char *) 0x86)=0x00;
	(*(unsigned char *) 0x89)=0x00;
	(*(unsigned char *) 0x88)=0x00;
	(*(unsigned char *) 0x8b)=0x00;
	(*(unsigned char *) 0x8a)=0x00;

// Timer/Counter2 
	(*(unsigned char *) 0xb6)=0x00;
	(*(unsigned char *) 0xb0)=0x00;
	(*(unsigned char *) 0xb1)=0x00;
	(*(unsigned char *) 0xb2)=0x00;
	(*(unsigned char *) 0xb3)=0x00;
	(*(unsigned char *) 0xb4)=0x00;

// External Interrupt(s) 
// INT0: Off
// INT1: Off
	(*(unsigned char *) 0x69)=0x00;
	EIMSK=0x00;
	EIFR=0x00;
	(*(unsigned char *) 0x68)=0x00;

// Timer(s)/Counter(s) Interrupt(s) 
	(*(unsigned char *) 0x6e)=0x00;
	(*(unsigned char *) 0x6f)=0x00;
	(*(unsigned char *) 0x70)=0x00;

//  ʱȭ
// 19200Bps, 8Data, 1 Stop, No Parity
	(*(unsigned char *) 0xc0)=0x00;
	(*(unsigned char *) 0xc1)=0x98;
	(*(unsigned char *) 0xc2)=0x06;
	(*(unsigned char *) 0xc5)=0x00;
	(*(unsigned char *) 0xc4)=0x40;

// Analog Comparator 
	ACSR=0x80;
	(*(unsigned char *) 0x7b)=0x00;

// Global enable interrupts
#asm("sei")
}

// ================================  ͷƮ =============================
// [μ] void
// ----------------------------------------------------------------------------
#pragma savereg-
interrupt [19] void uart_rx_isr(void)
{
char status,data;
#asm
	push r26
	push r27
	push r30
	push r31
	in   r26,sreg
	push r26
#endasm

	status = (*(unsigned char *) 0xc0);
	data = (*(unsigned char *) 0xc6);
	if((status & ((1<<4) | (1<<2) | (1<<3)))==0){
		com1_rx_data = data;
		com1_rx_eflg = 1;
	}

#asm
	pop  r26
	out  sreg,r26
	pop  r31
	pop  r30
	pop  r27
	pop  r26
#endasm
}
#pragma savereg+

// ========================== TIMER0 overflow ͷƮ ========================
// [μ] void
// [] 20,000,000 / 1024 / 195 =  1 / 100.1602564 = 9.9984ms
// ----------------------------------------------------------------------------
interrupt [17] void timer0_ovf_isr(void)
{
	TCNT0 = 60;						// 255-195 = 60
	timer0_cnt++;						// Ÿ̸0 ī
}

// ========================== TIMER1 overflow ͷƮ ========================
// [μ] void
// [] 20,000,000 / 64 / 3120 =  1 / 100.0 = 9.9984ms
// ----------------------------------------------------------------------------
interrupt [14] void timer1_ovf_isr(void)
{
	(*(unsigned char *) 0x85) = 0xf3;						// 65535 - 3120 = 62415
	(*(unsigned char *) 0x84) = 0xcf;
	timer1_cnt++;						// Ÿ̸1 ī
}

// ========================== TIMER2 overflow ͷƮ ========================
// [μ] void
// [] 20,000,000 / 1024 / 156 =  1 / 100.1602564 = 9.9984ms
// ----------------------------------------------------------------------------
interrupt [10] void timer2_ovf_isr(void)
{
	(*(unsigned char *) 0xb2) = 60;						// 255-195 = 60
	timer2_cnt++;						// Ÿ̸2 ī
}

// ========================== ܺ INT0 ͷƮ ==============================
// [μ] void
// ----------------------------------------------------------------------------
interrupt [2] void ext_int0_isr(void)
{
	exint0_flg = 1;						// EXINT0 ÷ ON
}

// ========================== ܺ INT1 ͷƮ ==============================
// [μ] void
// ----------------------------------------------------------------------------
interrupt [3] void ext_int1_isr(void)
{
	exint1_flg = 1;						// EXINT1 ÷ ON
}

// =============================== ADC ͷƮ ===============================
// [μ] void
// ----------------------------------------------------------------------------
interrupt [22] void adc_isr(void)
{
	adc_int_data = (*(unsigned int *) 0x78) ;					// ADC
	adc_int_flg = 1;					// ADC Ϸ ÷ 
}

// Լ 
void main_menu_disp(void);					//  ޴ ǥ
void cpu_ioport_output(void);					// CPU PORT I/O ׽Ʈ
void timer0_test(void);						// TIMER0 TEST
void timer1_test(void);						// TIMER1 TEST
void timer2_test(void);						// TIMER2 TEST
void exint_test(void);						// EXINT0,1 TEST
void ad_polling_test(void);					// A/D   TEST
unsigned int ad_read(unsigned char adc_input);			// A/D  ( )
void ad_interrupt_test(void);					// A/D ͷƮ  TEST
void ad_start(unsigned char adc_input);				// AD  (ͷƮ ) 
void eeprom_test(void);						// EEPROM TEST
void EEPROM_write(int addr,unsigned char data);			// EEPROM  
unsigned char EEPROM_read(int addr);				// EEPROM  

void urx_string(char buff[]);					// Ʈ 
long atoh(char buff[]);						// ASCII TO HEX 

//  

// ===============================  α׷ ==============================
// [μ]: void
// ---------------------------------------------------------------------------
void main(void)
{
	cpu_setup();						// cpuʱȭ
	main_menu_disp();					//  ޴ ǥ
	while(1){						// Place your code here
		if(com1_rx_eflg){				// COM1  ˻
			if(com1_rx_data == '1') cpu_ioport_output();// CPU I/O PORT TEST
			else if(com1_rx_data == '2') timer0_test(); // TIMER0 TEST
			else if(com1_rx_data == '3') timer1_test(); // TIMER1 TEST
			else if(com1_rx_data == '4') timer2_test(); // TIMER2 TEST
			else if(com1_rx_data == '5') exint_test();  // EXINT0,1 TEST
			else if(com1_rx_data == '6') ad_polling_test();// A/D POLLING TEST
			else if(com1_rx_data == '7') ad_interrupt_test(); // A/D POLLING TEST
			else if(com1_rx_data == '8') eeprom_test(); // EEPROM TEST
			else putchar(com1_rx_data);
			com1_rx_eflg = 0;
		}
	}
}

// =====================================  ޴ ǥ =======================
// [μ]: void
// ---------------------------------------------------------------------------
void main_menu_disp(void)
{
	printf("\r\n");
	printf("============== MAIN MENU =============\r\n");
	printf("- 1  : CPU I/O PORT TEST              \r\n");
	printf("- 2  : TIMER0 TEST                    \r\n");
	printf("- 3  : TIMER1 TEST                    \r\n");
	printf("- 4  : TIMER2 TEST                    \r\n");
	printf("- 5  : EXINT0,1 TEST                  \r\n");
	printf("- 6  : A/D POLLING   TEST             \r\n");
	printf("- 7  : A/D INTERRUPT TEST             \r\n");
	printf("- 8  : EEPROM TEST                    \r\n");
	printf("-------------- CPUPLAZA --------------\r\n");
}

// ============================== CPU_IO TEST =================================
// [μ]: void
// ----------------------------------------------------------------------------
void cpu_ioport_output(void)
{
int out_cnt,exit_flg = 0;

	printf("=========== CPU I/O PORT TEST =========\r\n");
	printf("- 0  : TOP menu                        \r\n");
	printf("---------------------------------------\r\n");
// CPU PORT   
// PORTB[0..5] : OUT 
	PORTB=0x3f;						// Ʈ  reg
	DDRB=0x3f;						// Ʈ  reg(0Է,1)
// PORTC[0..5] : OUT 
	PORTC=0x3f;						// Ʈ  reg
	DDRC=0x3f;						// Ʈ  reg(0Է,1)
// PORTD[2..7] : OUT 
	PORTD=0xfc;						// Ʈ  reg
	DDRD=0xfc;						// Ʈ  reg(0Է,1)

// LED  Ÿ Timer/Counter0 (Overflow) 9.9984ms
	TCCR0A = 0x00;
	TCCR0B = 0x05;						// system clock,20,000,000 / 1024 = 19.531Khz
	TCNT0 = 60;						// 255-195 = 60
	OCR0A=0x00;
	OCR0B=0x00;
	(*(unsigned char *) 0x6e) |= 0x01;						// TIMER0 ͷƮ 㰡

	timer0_cnt = 0;						// TIMER0 ͷƮ ī Ŭ
	out_cnt = 0;
	com1_rx_eflg = 0;
	while(exit_flg == 0){
		if(com1_rx_eflg){				// COM1  ˻
			if(com1_rx_data == '0') exit_flg = 1;	//  ޴ 
			else putchar(com1_rx_data);		// ݼ
			com1_rx_eflg = 0;
		}
		if(timer0_cnt >= 50){				// 500ms  
			if(out_cnt >= 0 && out_cnt <= 5) PORTB = ~(1 << out_cnt);// PORTB (ش Ʈ 0)
			else if(out_cnt >= 6 && out_cnt <= 11){	// PORTC 
				if(out_cnt == 6) PORTB = 0x3f;	// PORTB CLEAR
				PORTC = ~(1 << (out_cnt-6));	// PORTC (ش Ʈ 0)
			}
			else if(out_cnt >= 12 && out_cnt <= 17){// PORTD 
				if(out_cnt == 12) PORTC = 0x3f;	// PORTC CLEAR
				PORTD = ~(4 << (out_cnt-12));	// PORTD (ش Ʈ 0)
			}
			out_cnt++;				//  ġ ī 
			if(out_cnt >= 19) out_cnt = 0;		//  ġ ʰ ˻
			if(out_cnt == 0){			//  ü ʱȭ
				PORTB = 0x3f;
				PORTC = 0x3f;
				PORTD = 0xfc;
			}
			timer0_cnt = 0;
		}
	}

// Timer/Counter0 
	TCCR0A = 0x00;
	TCCR0B = 0x00;
	TCNT0 = 0;	
	(*(unsigned char *) 0x6e) &= 0xfe;						// TIMER0 ͷƮ 

// CPU PORT ʱⰪ  
// PORTB
	PORTB=0x00;						// Ʈ  reg
	DDRB=0x00;						// Ʈ  reg(0Է,1)
// PORTC
	PORTC=0x00;						// Ʈ  reg
	DDRC=0x00;						// Ʈ  reg(0Է,1)
// PORTD
	PORTD=0x00;						// Ʈ  reg
	DDRD=0x00;						// Ʈ  reg(0Է,1)
	
	main_menu_disp();					//  ޴ ǥ
}

// ============================== TIMER0 TEST =================================
// [μ]: void
// ----------------------------------------------------------------------------
void timer0_test(void)
{
int exit_flg = 0;

	printf("================ TIMER0 TEST ==============\r\n");
	printf("- 0  : TOP menu                            \r\n");
	printf("- interrupt    : TIMER0 Overfow 9.9984ms   \r\n");
	printf("- message disp : 9.9984ms * 100 = 999.84ms \r\n");
	printf("-------------------------------------------\r\n");

// Timer/Counter0 (Overflow)
	TCCR0A = 0x00;
	TCCR0B = 0x05;						// system clock,20,000,000 / 1024 = 19.531Khz
	TCNT0 = 60;						// 255-195 = 60
	OCR0A = 0x00;
	OCR0B = 0x00;
	(*(unsigned char *) 0x6e) |= 0x01;						// TIMER0 ͷƮ 㰡
	
	timer0_cnt = 0;						// TIMER0 ͷƮ ī Ŭ
	com1_rx_eflg = 0;
	while(exit_flg == 0){
		if(com1_rx_eflg){				// COM1  ˻
			if(com1_rx_data == '0') exit_flg = 1;	//  ޴ 
			else putchar(com1_rx_data);		// ݼ
			com1_rx_eflg = 0;
		}
		if(timer0_cnt >= 100){				// 999.84ms üũ
			printf("TIMER0 Overflow Interrupt\r\n");
			timer0_cnt = 0;
		}
	}

// Timer/Counter0 
	TCCR0A = 0x00;
	TCCR0B = 0x00;
	TCNT0 = 0;	
	OCR0A = 0x00;
	OCR0B = 0x00;
	(*(unsigned char *) 0x6e) &= 0xfe;						// TIMER0 ͷƮ 
	
	main_menu_disp();					//  ޴ ǥ
}

// ============================== TIMER1 TEST =================================
// [μ]: void
// ----------------------------------------------------------------------------
void timer1_test(void)
{
int exit_flg = 0;

	printf("============== TIMER1 TEST ============\r\n");
	printf("- 0  : TOP menu                        \r\n");
	printf("- interrupt   : TIMER1 Overfow 9.9984ms\r\n");
	printf("- message disp: 9.998ms * 100 = 90.998s\r\n");
	printf("---------------------------------------\r\n");

// Timer/Counter1 (Overflow)
	(*(unsigned char *) 0x80) = 0x00;
	(*(unsigned char *) 0x81) = 0x03;						// system clock,20,000,000 / 64 = 312.500Khz
	(*(unsigned char *) 0x85) = 0xf3;						// 65535 - 3120 = 62415
	(*(unsigned char *) 0x84) = 0xcf;
	(*(unsigned char *) 0x87)  = 0x00;
	(*(unsigned char *) 0x86) = 0x00;
	(*(unsigned char *) 0x89) = 0x00;
	(*(unsigned char *) 0x88) = 0x00;
	(*(unsigned char *) 0x8b) = 0x00;
	(*(unsigned char *) 0x8a) = 0x00;	
	(*(unsigned char *) 0x6f) |= 0x01;						// TIMER1 ͷƮ 㰡
	
	timer1_cnt = 0;						// TIMER1 ͷƮ ī Ŭ
	com1_rx_eflg = 0;
	while(exit_flg == 0){					// COM1  ˻
		if(com1_rx_eflg){
			if(com1_rx_data == '0') exit_flg = 1;	//  ޴ 
			else putchar(com1_rx_data);		// ݼ
			com1_rx_eflg = 0;
		}
		if(timer1_cnt >= 100){				// 1s üũ
			printf("TIMER1 Overflow Interrupt\r\n");
			timer1_cnt = 0;
		}
	}

// Timer/Counter1 
	(*(unsigned char *) 0x80) = 0x00;
	(*(unsigned char *) 0x81) = 0x00;
	(*(unsigned char *) 0x85) = 0x00;
	(*(unsigned char *) 0x84) = 0x00;
	(*(unsigned char *) 0x87)  = 0x00;
	(*(unsigned char *) 0x86) = 0x00;
	(*(unsigned char *) 0x89) = 0x00;
	(*(unsigned char *) 0x88) = 0x00;
	(*(unsigned char *) 0x8b) = 0x00;
	(*(unsigned char *) 0x8a) = 0x00;	
	(*(unsigned char *) 0x6f) &= 0xfe;						// TIMER1 ͷƮ 
	
	main_menu_disp();					//  ޴ ǥ
}

// ============================== TIMER2 TEST =================================
// [μ]: void
// ----------------------------------------------------------------------------
void timer2_test(void)
{
int exit_flg = 0;

	printf("=============== TIMER2 TEST ==============\r\n");
	printf("- 0  : TOP menu                           \r\n");
	printf("- interrupt    : TIMER0 Overfow 9.9984ms  \r\n");
	printf("- message disp : 9.9984ms * 100 = 999.84ms\r\n");
	printf("------------------------------------------\r\n");

// Timer/Counter2 (Overflow)
	(*(unsigned char *) 0xb6) = 0x00;
	(*(unsigned char *) 0xb0) = 0x00;
	(*(unsigned char *) 0xb1) = 0x07;						// system clock,20,000,000 / 1024 = 19.531Khz
	(*(unsigned char *) 0xb2) = 60;						// 255-195 = 60
	(*(unsigned char *) 0xb3) = 0x00;
	(*(unsigned char *) 0xb4) = 0x00;
	(*(unsigned char *) 0x70) |= 0x01;						// TIMER2 ͷƮ 
	
	timer2_cnt = 0;						// TIMER2 ͷƮ ī Ŭ
	com1_rx_eflg = 0;
	while(exit_flg == 0){
		if(com1_rx_eflg){				// COM1  ˻
			if(com1_rx_data == '0') exit_flg = 1;	//  ޴ 
			else putchar(com1_rx_data);		// ݼ
			com1_rx_eflg = 0;
		}
		if(timer2_cnt >= 100){				// 999.84ms üũ
			printf("TIMER2 Overflow Interrupt\r\n");
			timer2_cnt = 0;
		}
	}

// Timer/Counter2 
	(*(unsigned char *) 0xb6) = 0x00;
	(*(unsigned char *) 0xb0) = 0x00;
	(*(unsigned char *) 0xb1) = 0x00;
	(*(unsigned char *) 0xb2) = 0x00;
	(*(unsigned char *) 0xb3) = 0x00;
	(*(unsigned char *) 0xb4) = 0x00;
	(*(unsigned char *) 0x70) &= 0xfe;						// TIMER2 ͷƮ 
	
	main_menu_disp();					//  ޴ ǥ
}

// ============================== EXINT0,1 TEST ===============================
// [μ]: void
// ----------------------------------------------------------------------------
void exint_test(void)
{
int exit_flg = 0;

	printf("============== EXINT0,1 TEST ==========\r\n");
	printf("- 0  : TOP menu                        \r\n");
	printf("- interrupt : INT0 Falling Edge        \r\n");
	printf("-             INT1 Falling Edge        \r\n");
	printf("---------------------------------------\r\n");

// External Interrupt(s) 
// INT0 Mode: Falling Edge
// INT1 Mode: Falling Edge
	(*(unsigned char *) 0x69)=0x0A;
	EIMSK=0x03;
	EIFR=0x03;
	(*(unsigned char *) 0x68)=0x00;
	
	exint0_flg = exint1_flg = 0;				// EXINT0,1 ͷƮ ÷ Ŭ
	com1_rx_eflg = 0;
	while(exit_flg == 0){
		if(com1_rx_eflg){				// COM1  ˻
			if(com1_rx_data == '0') exit_flg = 1;	//  ޴ 
			else putchar(com1_rx_data);		// ݼ
			com1_rx_eflg = 0;
		}
		if(exint0_flg){					// EXINT0 ͷƮ ÷ üũ
			printf("EXINT0 Interrupt\r\n");
			exint0_flg = 0;
		}
		if(exint1_flg){					// EXINT1 ͷƮ ÷ üũ
			printf("EXINT1 Interrupt\r\n");
			exint1_flg = 0;
		}
	}

// External Interrupt(s) 
	(*(unsigned char *) 0x69)=0x00;
	EIMSK=0x00;
	EIFR=0x00;
	(*(unsigned char *) 0x68)=0x00;
	
	main_menu_disp();					//  ޴ ǥ
}

// ============================== A/D POLLING TEST ============================
// [μ]: void
// ----------------------------------------------------------------------------
void ad_polling_test(void)
{
unsigned datau;
int exit_flg = 0;

	printf("============ A/D POLLING TEST =========\r\n");
	printf("- 0  : TOP menu                        \r\n");
	printf("- 1  : CH0 READ                        \r\n");
	printf("- 2  : CH1 READ                        \r\n");
	printf("- 3  : CH2 READ                        \r\n");
	printf("- 4  : CH3 READ                        \r\n");
	printf("- 5  : CH4 READ                        \r\n");
	printf("- 6  : CH5 READ                        \r\n");
	printf("- 7  : CH6 READ                        \r\n");
	printf("- 8  : CH7 READ                        \r\n");
	printf("---------------------------------------\r\n");

// ADC initialization 
// 312.500kHz,AREF
	(*(unsigned char *) 0x7e)=0x00;
	(*(unsigned char *) 0x7c)=0x00;
	(*(unsigned char *) 0x7a)=0x86;

	com1_rx_eflg = 0;
	while(exit_flg == 0){
		if(com1_rx_eflg){				// COM1  ˻
			if(com1_rx_data == '0') exit_flg = 1;	//  ޴ 
			else if(com1_rx_data == '1') datau = ad_read(0);// CH0 
			else if(com1_rx_data == '2') datau = ad_read(1);// CH1 
			else if(com1_rx_data == '3') datau = ad_read(2);// CH2 
			else if(com1_rx_data == '4') datau = ad_read(3);// CH3 
			else if(com1_rx_data == '5') datau = ad_read(4);// CH4 
			else if(com1_rx_data == '6') datau = ad_read(5);// CH5 
			else if(com1_rx_data == '7') datau = ad_read(6);// CH6 
			else if(com1_rx_data == '8') datau = ad_read(7);// CH7 
			else putchar(com1_rx_data);		// ݼ
			// A/D  ǥ
			if(com1_rx_data >= '1' && com1_rx_data <= '8') printf("ADC CH%d > %d\r\n",(com1_rx_data&0x0f)-1,datau);
			com1_rx_eflg = 0;
		}
	}

// ADC initialization 
	(*(unsigned char *) 0x7e)=0x00;
	(*(unsigned char *) 0x7c)=0x00;
	(*(unsigned char *) 0x7a)=0x00;
	(*(unsigned char *) 0x7b)&=0xf8;	
	
	main_menu_disp();					//  ޴ ǥ
}

// ============================== A/D POLLING TEST ============================
// [μ]: unsigned char adc_input
// ITEM1 : AD CH(0-7)
// []: A/D 10bit
// ----------------------------------------------------------------------------
unsigned int ad_read(unsigned char adc_input)
{
	(*(unsigned char *) 0x7c) = adc_input;					// ADREF(0) + CH
	(*(unsigned char *) 0x7a) |= 0x40;						// AD conversion 
	while(((*(unsigned char *) 0x7a) & 0x10) == 0);				//  Ϸ 
	(*(unsigned char *) 0x7a) |= 0x10;						// AD ÷ Ŭ
	return (*(unsigned int *) 0x78) ;
}

// ============================== A/D INTERRUPT TEST ==========================
// [μ]: void
// ----------------------------------------------------------------------------
void ad_interrupt_test(void)
{
int exit_flg = 0;

	printf("=========== A/D INTEERRUPT TEST =======\r\n");
	printf("- 0  : TOP menu                        \r\n");
	printf("- 1  : CH0 READ                        \r\n");
	printf("- 2  : CH1 READ                        \r\n");
	printf("- 3  : CH2 READ                        \r\n");
	printf("- 4  : CH3 READ                        \r\n");
	printf("- 5  : CH4 READ                        \r\n");
	printf("- 6  : CH5 READ                        \r\n");
	printf("- 7  : CH6 READ                        \r\n");
	printf("- 8  : CH7 READ                        \r\n");
	printf("---------------------------------------\r\n");

// ADC initialization 
// ADC initialization 
// 312.500kHz,AREF :: ȯ ͷƮ
	(*(unsigned char *) 0x7e)=0x00;
	(*(unsigned char *) 0x7c)=0x00;
	(*(unsigned char *) 0x7a)=0x8e;
	
	adc_int_flg = 0;					// ADCϷ ͷƮ ÷
	adc_int_ch = 0;						// ADC CH = CH0
	com1_rx_eflg = 0;
	while(exit_flg == 0){
		if(com1_rx_eflg){				// COM1  ˻
			if(com1_rx_data == '0') exit_flg = 1;	//  ޴ 
			else if(com1_rx_data == '1') ad_start(0);// CH0 
			else if(com1_rx_data == '2') ad_start(1);// CH1 
			else if(com1_rx_data == '3') ad_start(2);// CH2 
			else if(com1_rx_data == '4') ad_start(3);// CH3 
			else if(com1_rx_data == '5') ad_start(4);// CH4 
			else if(com1_rx_data == '6') ad_start(5);// CH5 
			else if(com1_rx_data == '7') ad_start(6);// CH6 
			else if(com1_rx_data == '8') ad_start(7);// CH7 
			else putchar(com1_rx_data);		// ݼ
			// A/D  ǥ
			if(com1_rx_data >= '1' && com1_rx_data <= '8') printf("STAT ADC ");
			com1_rx_eflg = 0;
		}
		if(adc_int_flg){				// ADC  Ϸ ͷƮ ÷ 
			printf("CH%d > %d\r\n",adc_int_ch,adc_int_data);// ADC CH  ǥ
			adc_int_flg = 0;
		}
	}

// ADC initialization 
	(*(unsigned char *) 0x7e)=0x00;
	(*(unsigned char *) 0x7c)=0x00;
	(*(unsigned char *) 0x7a)=0x00;
	(*(unsigned char *) 0x7b)&=0xf8;	
	
	main_menu_disp();					//  ޴ ǥ
}

// ============================== A/D POLLING TEST ============================
// [μ]: unsigned char adc_input
// ITEM1 : AD CH(0-7)
// []: A/D 10bit
// ----------------------------------------------------------------------------
void ad_start(unsigned char adc_input)
{
	adc_int_ch = adc_input;					// ADC CH 
	(*(unsigned char *) 0x7c) = adc_input;					// ADREF(0) + CH
	(*(unsigned char *) 0x7a) |= 0x40;						// AD conversion 
}

// ================================ EEPROM TEST ===============================
// [μ]: void
// ----------------------------------------------------------------------------
void eeprom_test(void)
{
char ch,buff[100],buff1[30],buff2[30],buff3[30];
unsigned char uch;
int i,j,cnt,exit_flg = 0;
unsigned int saddr,ecnt;

	printf("========= INTERNAL EEPROM TEST ========\r\n");
	printf("- 0 : TOP menu                         \r\n");
	printf("  1 : Read  Data(000-1ffh)             \r\n");
	printf("  2 : Write Data(000-1ffh)             \r\n");
	printf("---------------------------------------\r\n");

	com1_rx_eflg = 0;
	while(exit_flg == 0){
		if(com1_rx_eflg){				// COM1  ˻
			if(com1_rx_data == '0') exit_flg = 1;	//  ޴ 
			else if(com1_rx_data == '1'){
				i = j = cnt = 0;
				printf("\r\nREAD(###(Add),***(Count)) > ");
				urx_string(buff);
				ch = buff[i++];			//  ˻ ڷ 
				while(ch != 0x0){
					if((ch == ':') || (ch == ',') || (ch == ' ')){
						j = 0;
						cnt++;
					}
					else{
						if(cnt == 0){
							buff1[j++] = ch;
							buff1[j] = 0x0;
						}
						else if(cnt == 1){
				    			buff2[j++] = ch;
				    			buff2[j] = 0x0;
						}
			    		}
				    	ch = buff[i++];
				}
				if(cnt == 1){			// ˻ 
					saddr = (unsigned int)atoh(buff1);//  ּ ȯ(HEX)
					ecnt = (unsigned int)atoh(buff2);// ī ȯ(HEX)
					printf("%04X > ",saddr);// ּ ǥ
					cnt = 0;
			   		for(i = 0; i <= ecnt; i++,saddr++){//  ǥ	
						uch = EEPROM_read(saddr);//  
						printf("%02X ",uch);// Ÿ ǥ
						cnt++;
						if(cnt == 16){// 1 ǥ
							cnt = 0;
							if(i+1 <= ecnt) printf("\r\n%03X > ",saddr+1);// ּ ǥ
						}
				    	}
					printf("\r\nRead OK\r\n");
				}
			}
			else if(com1_rx_data == '2'){
				i = j = cnt = 0;
				printf("\r\nWRITE(###(Addr),***(Count),**(Data)) > ");
				urx_string(buff);
				ch = buff[i++];			//  ˻ ڷ 
				while(ch != 0x0){
					if((ch == ':') || (ch == ',') || (ch == ' ')){
						j = 0;
						cnt++;
					}
					else{
						if(cnt == 0){
							buff1[j++] = ch;
							buff1[j] = 0x0;
						}
						else if(cnt == 1){
							buff2[j++] = ch;
							buff2[j] = 0x0;
						}
						else if(cnt == 2){
							buff3[j++] = ch;
							buff3[j] = 0x0;
						}
					}
					ch = buff[i++];
				}
				if(cnt == 2){			// ˻ 
					saddr = (unsigned int)atoh(buff1);//  ּ ȯ(HEX)
					ecnt = (unsigned int)atoh(buff2);// ī ּ ȯ(HEX)
					uch = (unsigned char)atoh(buff3);//  ȯ(HEX)
					for(i = 0; i <= ecnt; i++,saddr++) EEPROM_write(saddr,uch);//  
					printf("SRAM Data Write OK\r\n");
				}
			}
			else putchar(com1_rx_data);		// ݼ
			com1_rx_eflg = 0;
		}
	}
	main_menu_disp();					//  ޴ ǥ
}

// ============================== EEPROM DATA READ ============================
// [μ] int addr
// Item1:  ּ(0 - 511)
// []  (00 - ff)
// ----------------------------------------------------------------------------
unsigned char EEPROM_read(int addr)
{
unsigned char ch;

	while(EECR & 0x02);					//   Ϸñ 
	EEAR = addr;
	EECR |= 0x01;
	ch = EEDR;
	return(ch);
}

// ============================== EEPROM DATA  ============================
// [μ] int addr,unsigned char data
// Item1:  ּ(0 - 511)
// Item2:  (00 - ff)
// ----------------------------------------------------------------------------
void EEPROM_write(int addr,unsigned char data)
{
	while(EECR & 0x02);					//   Ϸñ 
	EEAR = addr;
	EEDR = data;
	EECR |= 0x04;
	EECR |= 0x02;
}

// ============================ κ ڿ  ====================
// [μ] char buff[]					     
// Item1   Ÿ  (ִ 30)			     
// ----------------------------------------------------------------------------
void urx_string(char buff[])
{
char ch;
int exit_flg = 0,scnt = 0;

	com1_rx_eflg = 0;
	buff[0] = 0x0;						//  ũ
	while(exit_flg == 0){
	    while(com1_rx_eflg == 0); com1_rx_eflg = 0;		// 1 
	    ch = com1_rx_data;					//  Ÿ ε
	    ch = toupper(ch);					//  ȯ
	    if(ch == 0x08){					// BSŰ м
			if(scnt == 0) putchar(0x07);		//  溸 ۽
			else{					// 1ڸ 
			    putchar(0x08);
			    putchar(' ');
			    putchar(0x08);
			    scnt--;
			}
	    }
	    else if(ch == 0x0d){
			exit_flg = 1;				// Ż  ON
			buff[scnt] = 0x0;
			printf("\r\n");
	    }
	    else{
			buff[scnt++] = ch;			// ڷ 
			putchar(ch);
			if(scnt >= 30){ 			//   ʰ 
			    scnt = 29;
			    putchar(0x08);
			    putchar(0x07);
			}
	    }
	}
}

// ========================== ASCII͸ HEXͷ ȯ ==================
// [μ] unsigned char buff[]					    
// Item1  ȯ  					    
// [] 0 - 7fffffffh 					    
// ----------------------------------------------------------------------------
long atoh(char buff[])
{
char ch;
int i = 0;
long data = 0;

	ch = buff[i++]; 					//  ε
	ch = toupper(ch);					// 빮 ȯ
	while(ch != 0){
		ch = ch - '0';              			// 0 - 9 ȯ 
		if(ch > 9) ch = ch - 7;				// A - F ȯ
		if(ch < 0 || ch > 0x0f) ch = 0;			//  ˻
		else ch = ch & 0x0f;
		data = data << 4;				// ȯ  
		data |= ch;
		ch = buff[i++];					//  ε
		ch = toupper(ch);				// 빮 ȯ 
	}
	return(data);
}
